Search.setIndex({"docnames": ["api/exceptions", "api/filters", "api/main", "api/models", "api/settings", "index", "installation", "references/arch", "references/contributing", "references/debugging", "references/resources", "releasenotes/index", "releasenotes/version0", "releasenotes/version1", "releasenotes/version2", "releasenotes/version3", "releasenotes/version4", "releasenotes/version5", "topics/attachments", "topics/content_streams", "topics/encoding", "topics/images", "topics/metadata", "topics/nametrees", "topics/objects", "topics/outlines", "topics/overlays", "topics/page", "topics/pagelayout", "topics/pages", "topics/security", "topics/streams", "tutorial"], "filenames": ["api/exceptions.rst", "api/filters.rst", "api/main.rst", "api/models.rst", "api/settings.rst", "index.rst", "installation.rst", "references/arch.rst", "references/contributing.rst", "references/debugging.rst", "references/resources.rst", "releasenotes/index.rst", "releasenotes/version0.rst", "releasenotes/version1.rst", "releasenotes/version2.rst", "releasenotes/version3.rst", "releasenotes/version4.rst", "releasenotes/version5.rst", "topics/attachments.rst", "topics/content_streams.rst", "topics/encoding.rst", "topics/images.rst", "topics/metadata.rst", "topics/nametrees.rst", "topics/objects.rst", "topics/outlines.rst", "topics/overlays.rst", "topics/page.rst", "topics/pagelayout.rst", "topics/pages.rst", "topics/security.rst", "topics/streams.rst", "tutorial.rst"], "titles": ["Exceptions", "Content streams", "Main objects", "Support models", "Settings", "pikepdf Documentation", "Installation", "Architecture", "Contributing guidelines", "Debugging", "Resources", "Release notes", "v0.10.2", "v1.19.4", "v2.16.1", "v3.2.0", "v4.5.0", "v5.6.1", "Attaching files to a PDF", "Working with content streams", "Character encoding", "Working with images", "Metadata", "Name trees", "Object model", "Outlines", "Overlays, underlays, watermarks, n-up", "Working with pages", "Default appearance in PDF viewers", "PDF split, merge, and document assembly", "PDF security", "Stream objects", "Tutorial"], "terms": {"pdf": [0, 1, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 20, 21, 23, 25, 26, 27, 31], "1": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "7": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "refer": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "manual": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "10": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "6": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 15, 16, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "2": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "3": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 15, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "pikepdf": [0, 1, 2, 3, 4, 6, 7, 8, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "pdferror": [0, 2], "gener": [0, 2, 3, 5, 6, 7, 8, 9, 12, 13, 14, 16, 17, 19, 21, 22, 24, 30, 32], "specif": [0, 1, 2, 3, 5, 10, 13, 14, 20, 22, 23, 24, 25, 29, 31], "passworderror": [0, 2], "thrown": [0, 2, 3, 13], "when": [0, 1, 2, 3, 4, 7, 8, 12, 13, 14, 15, 17, 18, 19, 20, 21, 22, 24, 25, 26, 28, 29, 31, 32], "suppli": [0, 2], "password": [0, 2, 3, 5, 13, 14, 15, 32], "incorrect": [0, 14, 16], "foreignobjecterror": [0, 2, 14], "complex": [0, 3, 9, 15, 21, 22, 23, 29, 32], "object": [0, 1, 3, 5, 7, 8, 12, 13, 14, 15, 16, 17, 18, 19, 21, 22, 23, 26, 27, 28, 29, 32], "wa": [0, 1, 2, 3, 7, 12, 13, 14, 15, 16, 17, 24, 27, 29], "copi": [0, 2, 3, 5, 6, 7, 12, 13, 14, 16, 22, 24, 26], "foreign": [0, 2, 13], "without": [0, 2, 3, 5, 13, 15, 16, 21, 25, 30], "us": [0, 1, 2, 3, 4, 6, 7, 8, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 28, 30, 31, 32], "copy_foreign": [0, 2, 14, 16], "outlinestructureerror": [0, 2, 3], "indic": [0, 2, 3, 13, 21, 32], "an": [0, 1, 2, 3, 5, 6, 7, 12, 13, 14, 15, 16, 17, 18, 19, 22, 23, 24, 25, 26, 27, 29, 30, 31, 32], "error": [0, 2, 3, 12, 13, 14, 15, 16, 17, 31], "outlin": [0, 2, 3, 5, 13, 14, 15, 23, 28], "data": [0, 1, 3, 5, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 27, 29, 31, 32], "structur": [0, 3, 5, 14, 15, 19, 23, 24, 27, 29, 32], "violat": 0, "constraint": [0, 17], "impos": [0, 3], "unsupportedimagetypeerror": 0, "thi": [0, 1, 2, 3, 6, 7, 8, 9, 10, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 29, 30, 31, 32], "imag": [0, 1, 2, 3, 5, 10, 12, 13, 14, 15, 16, 17, 24, 26, 27, 28, 31, 32], "format": [0, 2, 3, 5, 8, 9, 13, 14, 15, 19, 21, 22], "wai": [0, 2, 3, 12, 13, 14, 15, 16, 21, 24, 26], "doe": [0, 1, 2, 3, 5, 6, 9, 14, 16, 19, 21, 24, 27, 29, 30, 31], "support": [0, 2, 5, 7, 9, 12, 13, 14, 15, 16, 17, 26, 27, 30, 32], "attempt": [0, 2, 3, 6, 13, 14, 15, 31], "manipul": [0, 2, 3, 5, 13, 15, 17, 19, 21, 23, 30, 32], "type": [0, 1, 2, 3, 5, 8, 12, 13, 14, 15, 16, 17, 18, 21, 22, 23, 24, 27, 31, 32], "current": [0, 2, 3, 5, 6, 7, 9, 12, 13, 16, 19, 21, 22, 29], "datadecodingerror": [0, 16], "stream": [0, 3, 5, 12, 13, 14, 15, 16, 17, 21, 22, 24, 26, 27, 32], "malform": [0, 2, 13], "cannot": [0, 2, 3, 5, 6, 9, 19, 20, 21, 31, 32], "decod": [0, 2, 3, 13, 14, 16, 17, 19, 20, 21, 22, 31], "In": [1, 2, 3, 6, 7, 8, 9, 13, 15, 16, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 29, 30, 31, 32], "draw": [1, 2, 3, 5, 21, 26, 27, 31], "oper": [1, 2, 3, 6, 9, 13, 16, 17, 19, 20, 21, 24, 31], "ar": [1, 2, 3, 5, 6, 7, 8, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32], "all": [1, 2, 3, 5, 6, 7, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 29, 30, 31, 32], "perform": [1, 2, 3, 6, 7, 12, 13, 14, 20, 26], "describ": [1, 2, 3, 13, 15, 19, 21, 22, 27, 31], "posit": [1, 2, 3, 12, 19, 21, 26, 29], "order": [1, 2, 3, 5, 18, 20, 31], "graphic": [1, 2, 3, 19, 26, 31], "includ": [1, 2, 3, 5, 6, 7, 8, 10, 13, 14, 17, 18, 21, 23, 30, 32], "text": [1, 2, 3, 5, 13, 18, 24, 31], "vector": [1, 3, 16, 19, 21], "work": [1, 2, 3, 5, 6, 7, 8, 9, 12, 13, 14, 16, 24, 26, 29, 31, 32], "libqpdf": [1, 2, 3, 6, 9, 12, 13, 14, 15, 16, 17], "provid": [1, 2, 3, 5, 6, 9, 11, 13, 14, 15, 17, 18, 19, 21, 22, 23, 24, 28, 29, 31, 32], "two": [1, 2, 3, 14, 16, 20, 22, 24, 25, 28, 29], "tool": [1, 2, 3, 9, 19, 22, 27], "interpret": [1, 2, 3, 7, 13, 14, 19, 20], "The": [1, 2, 3, 5, 6, 7, 8, 9, 11, 12, 13, 14, 17, 18, 19, 20, 21, 24, 25, 26, 27, 29, 31, 32], "return": [1, 2, 3, 7, 13, 14, 15, 17, 20, 22, 24, 27], "higher": [1, 2, 3, 6, 7, 19], "level": [1, 2, 3, 4, 5, 7, 13, 14, 19], "inform": [1, 2, 3, 5, 9, 10, 12, 13, 21, 22, 23, 24, 27, 32], "conveni": [1, 2, 3, 6, 13, 22, 24, 29, 32], "group": [1, 2, 21, 26, 28, 31], "command": [1, 2, 6, 14, 19, 21, 31, 32], "operand": [1, 2, 19], "one": [1, 2, 3, 5, 6, 7, 8, 9, 13, 14, 18, 19, 21, 22, 24, 28, 29, 31], "want": [1, 2, 3, 5, 6, 9, 13, 18, 20, 26, 29], "retriev": [1, 2, 3, 12, 18, 21], "from": [1, 2, 3, 5, 7, 8, 9, 12, 13, 14, 16, 18, 20, 21, 22, 23, 24, 25, 26, 27, 28, 32], "determin": [1, 2, 3, 13, 20, 21, 24], "element": [1, 3, 5, 13, 14, 22, 25, 32], "should": [1, 2, 3, 6, 7, 8, 9, 11, 12, 13, 14, 15, 17, 18, 19, 20, 21, 22, 24, 29, 30, 32], "edit": [1, 2, 3, 5, 6, 12, 13, 22, 27], "reconstruct": [1, 2], "becaus": [1, 2, 3, 6, 7, 8, 12, 13, 14, 19, 21, 22, 24, 29, 30, 31, 32], "some": [1, 2, 3, 4, 5, 6, 7, 8, 9, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 26, 29, 30, 31], "subtleti": 1, "lost": 1, "pars": [1, 2, 3, 5, 12, 13, 14, 16, 17, 19], "lower": [1, 2, 3], "consid": [1, 2, 3, 5, 6, 12, 14, 19, 22], "each": [1, 2, 7, 8, 12, 13, 18, 19, 20, 24, 25, 29, 31], "comment": [1, 2, 3, 14, 19], "distinguish": 1, "differ": [1, 2, 3, 6, 8, 9, 13, 14, 15, 18, 21, 22, 26, 29, 31, 32], "space": [1, 21, 26], "allow": [1, 2, 3, 5, 13, 17, 21, 24, 25, 30, 32], "modifi": [1, 2, 3, 5, 6, 7, 12, 13, 14, 17, 22, 29, 32], "A": [1, 2, 3, 5, 12, 13, 14, 19, 21, 23, 24, 25, 29, 31, 32], "tokenfilt": [1, 3, 14], "must": [1, 2, 3, 6, 8, 12, 19, 22, 24], "subclass": [1, 3, 15, 16, 24, 31], "special": [1, 2, 3, 9, 14, 15, 24, 27, 31, 32], "version": [1, 2, 3, 6, 9, 11, 13, 14, 16, 17, 18, 20, 22, 29, 32], "how": [1, 2, 3, 5, 9, 13, 14, 26, 27, 28, 29, 30, 31, 32], "transform": [1, 3, 5, 13, 19, 26, 27], "parse_content_stream": [1, 2, 14, 15, 17, 19], "page_or_stream": 1, "sequenc": [1, 2, 3, 21], "instruct": [1, 2, 6, 19, 27, 31], "list": [1, 2, 3, 13, 14, 15, 18, 19, 21, 22, 24, 25, 29, 32], "where": [1, 2, 3, 6, 12, 13, 14, 16, 17, 19, 20, 21, 25], "render": [1, 2, 3, 31], "start": [1, 2, 3], "point": [1, 2, 7, 19, 20, 24], "analyz": 1, "If": [1, 2, 3, 5, 6, 7, 8, 12, 13, 15, 18, 19, 20, 21, 22, 24, 26, 29, 30], "input": [1, 2, 3, 5, 13, 15, 19, 28, 32], "page": [1, 2, 3, 5, 6, 7, 9, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 23, 24, 25, 26, 28, 31], "arrai": [1, 2, 3, 12, 13, 14, 15, 16, 18, 19, 23, 24, 27], "automat": [1, 2, 3, 5, 12, 13, 14, 15, 16, 17, 20, 25, 29, 31], "treat": [1, 2, 20, 24, 29], "coalesc": [1, 2, 3], "contain": [1, 2, 3, 5, 8, 12, 13, 14, 17, 18, 19, 21, 22, 24, 26, 27, 29, 31, 32], "least": [1, 14], "zero": [1, 3, 19, 25], "more": [1, 2, 3, 5, 6, 7, 9, 12, 13, 14, 15, 16, 17, 19, 21, 22, 24, 25, 26, 29, 30, 31, 32], "function": [1, 2, 3, 7, 9, 12, 13, 14, 16, 17, 20, 29, 31, 32], "have": [1, 2, 3, 6, 7, 8, 9, 12, 13, 14, 15, 16, 17, 18, 19, 24, 29, 30, 31, 32], "anyth": [1, 21], "do": [1, 2, 3, 5, 6, 7, 12, 14, 15, 18, 19, 20, 26, 27, 29, 30, 31], "open": [1, 2, 3, 5, 7, 8, 9, 12, 13, 14, 15, 18, 19, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30], "file": [1, 2, 3, 5, 6, 8, 9, 10, 12, 13, 14, 15, 16, 17, 19, 20, 21, 22, 23, 24, 25, 26, 29, 30, 31, 32], "itself": [1, 2, 13, 24, 31], "process": [1, 2, 3, 7, 9, 14, 19, 24], "whole": [1, 2, 3, 29], "It": [1, 2, 3, 5, 6, 7, 9, 12, 13, 14, 15, 19, 21, 22, 26, 29, 30, 31], "insid": [1, 2, 3, 9, 12, 13, 19, 31], "alreadi": [1, 2, 3, 5, 6, 8, 14, 20, 29], "paramet": [1, 2, 3, 4, 12, 13, 14, 15, 16, 21], "_qpdf": [1, 2, 3, 6, 7, 9, 11, 16, 17, 18, 19], "attach": [1, 2, 3, 5, 12, 13, 15, 16, 17, 22, 23, 24, 27, 28, 31], "anoth": [1, 2, 3, 5, 7, 9, 13, 14, 19, 21, 22, 24, 25, 29, 31], "form": [1, 2, 3, 5, 13, 14, 19, 21, 26, 30, 31], "xobject": [1, 2, 3, 12, 13, 19, 21, 26, 27, 31, 32], "str": [1, 2, 3, 13, 15, 20, 24], "separ": [1, 8, 15, 19], "string": [1, 2, 3, 8, 12, 13, 14, 20, 24, 30, 32], "whitelist": 1, "For": [1, 2, 3, 9, 10, 13, 14, 19, 22, 24, 25, 26, 27, 28, 30, 32], "exampl": [1, 2, 3, 5, 6, 7, 9, 14, 16, 18, 19, 21, 22, 24, 25, 26, 27, 29, 32], "q": [1, 3, 19, 26], "cm": [1, 19], "onli": [1, 2, 3, 5, 6, 8, 12, 13, 14, 17, 18, 19, 20, 21, 22, 24, 30, 31, 32], "pertain": 1, "bi": [1, 2], "id": [1, 2, 22, 23], "ei": [1, 2], "inlin": [1, 2, 3, 12, 13, 14, 15, 17], "other": [1, 2, 3, 5, 8, 10, 13, 14, 15, 16, 17, 18, 21, 22, 24, 26, 28, 30, 31, 32], "associ": [1, 2, 3, 10, 12, 19, 29], "ignor": [1, 2, 3, 13, 17, 28], "blank": [1, 2, 3, 29, 30], "accept": [1, 12, 14, 15, 29, 32], "union": [1, 2], "contentstreaminstruct": [1, 2, 15], "contentstreaminlineimag": [1, 2, 15], "input_pdf": 1, "0": [1, 2, 3, 4, 6, 10, 11, 18, 19, 20, 21, 22, 23, 25, 26, 27, 29, 31, 32], "print": [1, 2, 3, 5, 15, 22, 23, 26], "chang": [1, 2, 3, 5, 9, 13, 14, 17, 20, 22, 24, 28, 29], "instead": [1, 2, 3, 5, 6, 8, 9, 12, 13, 14, 15, 21, 22, 23, 26, 29], "tupl": [1, 2, 3, 14], "item": [1, 2, 3, 5, 13, 15, 21, 25], "duck": [1, 15], "compat": [1, 2, 8, 13, 14, 15, 17, 20, 22, 30], "previou": [1, 3, 13, 14, 15, 16], "unparse_content_stream": [1, 2, 13, 14, 15, 19], "convert": [1, 2, 3, 4, 5, 13, 14, 19, 20, 21, 24, 26], "collect": [1, 2, 3], "byte": [1, 2, 3, 14, 15, 20, 22, 24, 31], "suitabl": [1, 3, 21, 24], "store": [1, 2, 3, 22, 23], "given": [1, 2, 3, 13, 17, 19], "embed": [1, 2, 3, 5, 13, 14, 18, 23, 24], "alwai": [1, 2, 3, 8, 13, 14, 17, 19, 24, 32], "follow": [1, 3, 6, 8, 19, 25, 27, 29, 30, 32], "unparseablecontentstreaminstruct": 1, "binari": [1, 2, 3, 5, 9, 12, 13, 14, 16, 17, 19, 20, 21, 24, 31], "To": [1, 2, 3, 6, 9, 19, 21, 22, 23, 26, 27, 29, 31, 32], "make_stream": [1, 2, 13, 19, 21], "now": [1, 2, 3, 12, 13, 14, 15, 16, 17, 18, 22, 29, 32], "ani": [1, 2, 3, 9, 11, 14, 15, 18, 21, 23, 24, 28, 29, 30, 32], "mixtur": 1, "older": [1, 2, 3, 6, 13, 14, 20, 22], "x": [1, 2, 3, 5, 13, 14, 15, 16, 22, 27, 32], "class": [1, 2, 3, 8, 13, 14, 15, 16, 21, 24, 32], "properti": [1, 2, 3, 12, 13, 21, 22, 27, 32], "raw_valu": 1, "represent": [1, 2, 3, 15, 19], "type_": 1, "tokentyp": [1, 15], "valu": [1, 2, 3, 12, 13, 16, 22, 24, 27, 28, 32], "label": [1, 3, 5, 14, 17, 32], "accord": [1, 2, 3, 14, 32], "role": 1, "plai": [1, 5], "standard": [1, 2, 3, 9, 13, 16, 20, 21, 22, 32], "array_open": 1, "array_clos": 1, "brace_open": 1, "brace_clos": 1, "dict_open": 1, "dict_clos": 1, "These": [1, 2, 3, 5, 6, 13, 15, 19, 21, 24, 28], "mark": [1, 2, 3, 13, 16, 17, 20], "end": [1, 2, 3, 12, 13, 14, 16, 19, 22, 26], "dictionari": [1, 2, 3, 5, 12, 13, 14, 15, 18, 19, 21, 23, 24, 27, 28, 29, 31], "respect": [1, 2, 3, 5, 15, 22], "integ": [1, 2, 3, 12, 24], "real": [1, 2, 12, 19, 30], "null": [1, 2, 12, 17, 24], "bool": [1, 2, 3, 12, 24], "repres": [1, 2, 3, 14, 24, 31, 32], "number": [1, 2, 3, 4, 5, 12, 13, 14, 16, 17, 19, 24, 25, 27, 28, 31, 32], "boolean": [1, 2, 12, 24], "name_": [1, 2, 15], "name": [1, 2, 3, 5, 6, 7, 8, 9, 12, 13, 14, 15, 16, 17, 18, 19, 21, 22, 24, 25, 28, 31, 32], "practic": [1, 3, 5, 30], "among": 1, "most": [1, 2, 3, 6, 13, 14, 15, 19, 20, 22, 24, 29, 30, 31], "interest": [1, 3, 8, 13, 31, 32], "than": [1, 2, 3, 5, 6, 7, 8, 9, 13, 14, 15, 19, 22, 26, 29, 30], "interf": [1, 15], "semant": [1, 2, 3, 11, 13, 14, 22], "enum": [1, 15], "so": [1, 2, 3, 6, 7, 9, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 24, 27, 29, 32], "fix": [1, 2, 3, 13, 14, 16, 17, 19, 20], "inline_imag": 1, "singl": [1, 2, 3, 5, 8, 21, 24, 25, 27, 32], "lexic": 1, "signifi": 1, "appear": [1, 2, 3, 5, 13, 14, 21, 32], "word": [1, 31], "otherwis": [1, 2, 3, 6, 14, 19, 20, 31], "uncategor": 1, "bad": 1, "invalid": [1, 2, 5, 12, 13, 17, 24], "whitespac": [1, 19], "within": [1, 2, 3, 5, 8, 11, 12, 13, 21, 25, 26, 32], "eof": 1, "denot": [1, 2], "handle_token": [1, 14], "self": [1, 2, 3], "handl": [1, 2, 3, 5, 12, 13, 14, 16, 17, 24, 25], "abstract": [1, 2, 3], "method": [1, 2, 3, 8, 9, 12, 13, 17, 21, 24, 29], "defin": [1, 2, 3, 13, 14, 16, 17, 20, 27, 29, 31], "call": [1, 2, 3, 13, 14, 15, 24, 25, 29, 31, 32], "implement": [1, 2, 3, 6, 7, 12, 13, 14, 18, 19, 20, 24, 30], "mai": [1, 2, 3, 6, 7, 9, 13, 14, 15, 16, 18, 19, 20, 21, 22, 24, 26, 28, 29, 30, 31, 32], "either": [1, 2, 3, 14, 16, 19, 25], "none": [1, 2, 3, 4, 12, 24], "discard": [1, 17, 22], "origin": [1, 2, 3, 13, 14, 19, 24], "new": [1, 2, 3, 5, 12, 13, 14, 17, 18, 19, 21, 22, 24, 25, 26, 27, 29, 30, 32], "iter": [1, 2, 3, 12, 13, 16, 21], "also": [1, 2, 3, 5, 6, 7, 8, 9, 13, 14, 18, 19, 20, 21, 22, 24, 25, 26, 27, 29, 32], "buffer": [1, 2, 3, 13], "releas": [1, 2, 6, 12, 13, 14, 16, 17], "them": [1, 2, 3, 5, 6, 7, 9, 13, 14, 19, 21, 23, 26, 28, 29, 31, 32], "could": [1, 2, 13, 14, 19, 21, 22, 29, 31, 32], "entir": [1, 2, 13, 30], "its": [1, 2, 3, 5, 6, 12, 13, 14, 18, 19, 20, 21, 22, 24, 29, 30, 31], "final": [1, 2, 3, 12, 13, 19], "unless": [1, 8, 9, 14, 25], "except": [1, 2, 3, 5, 6, 12, 13, 14, 15, 17, 22, 29], "rais": [1, 2, 3, 12, 13, 14, 15, 29], "caught": 1, "c": [1, 3, 5, 6, 7, 11, 12, 13, 14, 16, 19, 24], "consum": 1, "replac": [1, 2, 5, 12, 13, 16, 17, 19, 29], "less": [1, 2, 3, 12, 14], "get_warn": [1, 2, 13], "view": [1, 2, 3, 9, 18, 21, 27, 30, 32], "memori": [2, 3, 5, 7, 9, 12, 13, 14, 17, 18, 32], "root": [2, 3, 5, 6, 14, 15, 18, 22, 23, 24, 25, 28, 32], "add_blank_pag": [2, 13], "page_s": 2, "612": 2, "792": 2, "add": [2, 3, 5, 6, 12, 13, 14, 25, 26, 29], "exist": [2, 3, 5, 12, 13, 14, 22, 24, 25, 26, 27, 32], "ad": [2, 3, 12, 13, 14, 15, 16, 17, 18, 25], "reorder": 2, "caller": [2, 3], "after": [2, 3, 7, 12, 13, 14, 15, 17, 19, 22, 24, 32], "creat": [2, 3, 5, 9, 12, 13, 14, 16, 17, 21, 22, 24, 26, 29, 30, 32], "size": [2, 3, 5, 14, 16, 19, 21], "unit": [2, 3, 19, 27, 29], "72": [2, 18, 19, 27], "inch": 2, "35mm": 2, "default": [2, 3, 4, 5, 13, 16, 22, 25, 26, 32], "set": [2, 3, 5, 6, 8, 9, 12, 13, 14, 16, 17, 18, 21, 22, 25, 28, 30, 32], "letter": [2, 3], "8": [2, 3, 6, 11, 12, 15, 16, 17, 18, 19, 21, 22, 23, 25, 27, 29, 30, 32], "5": [2, 3, 5, 11, 18, 19, 20, 21, 22, 23, 25, 26, 27, 29, 32], "11": [2, 3, 6, 11, 18, 21, 22, 25, 29, 32], "permiss": [2, 3, 14, 30, 32], "report": [2, 3, 13, 14, 17, 29], "By": [2, 3, 5, 22, 26, 32], "replic": [2, 3, 24, 32], "save": [2, 3, 5, 6, 7, 8, 12, 13, 14, 15, 17, 19, 22, 25, 26, 28, 29, 30, 31], "being": [2, 3, 5, 6, 7, 13, 14, 16, 17, 19], "avail": [2, 3, 5, 12, 13, 18, 20, 22, 28], "encrypt": [2, 3, 5, 13, 17, 18, 30, 32], "ha": [2, 3, 5, 6, 8, 12, 13, 14, 15, 16, 19, 21, 22, 24, 27, 29, 30], "enforc": [2, 3, 30], "map": [2, 3, 13, 19, 20, 24], "access": [2, 3, 5, 7, 9, 11, 12, 13, 15, 21, 23, 24, 27, 30, 31, 32], "you": [2, 3, 5, 6, 7, 8, 9, 13, 15, 18, 19, 20, 21, 22, 24, 26, 27, 28, 29, 30, 31, 32], "prefer": [2, 8, 18, 25, 28, 32], "read": [2, 3, 5, 6, 7, 12, 13, 19, 22, 26, 32], "write": [2, 3, 5, 6, 7, 9, 12, 13, 19, 21, 32], "filenam": [2, 3, 12, 13, 14, 18, 21, 32], "check": [2, 3, 5, 6, 8, 13, 14, 16, 17, 24, 30, 32], "well": [2, 3, 5, 13, 14, 19, 21], "similar": [2, 3, 8, 13, 21, 24], "qpdf": [2, 3, 5, 7, 8, 10, 12, 13, 14, 15, 16, 17], "check_linear": 2, "sy": 2, "stderr": 2, "s": [2, 3, 4, 5, 6, 8, 9, 12, 13, 14, 15, 17, 18, 19, 20, 21, 22, 24, 26, 27, 28, 29, 30, 31, 32], "linear": [2, 5, 17], "too": [2, 8, 12, 14, 32], "flush": 2, "true": [2, 3, 12, 13, 21, 24], "correctli": [2, 3, 13], "fals": [2, 3, 14, 22, 26, 32], "incorrectli": [2, 13, 14], "runtimeerror": 2, "question": [2, 19], "close": [2, 3, 13, 14, 15, 18, 24, 29, 32], "resourc": [2, 3, 5, 12, 13, 14, 18, 19, 21, 22, 23, 27, 29, 32], "acquir": 2, "e": [2, 3, 5, 6, 8, 12, 13, 20, 25], "g": [2, 3, 6, 8, 9, 12, 13, 25], "path": [2, 3, 6, 17, 18, 32], "block": [2, 3, 13, 17, 22, 29], "exit": [2, 13, 22], "lazili": [2, 3, 24], "load": [2, 3, 9, 13, 14, 24, 28], "implicitli": [2, 3], "depend": [2, 5, 6, 12, 13, 14, 15, 16, 22, 24, 30], "case": [2, 3, 5, 12, 13, 14, 15, 17, 19, 20, 21, 23, 24, 25, 27, 32], "can": [2, 3, 4, 5, 6, 7, 8, 9, 12, 13, 14, 16, 18, 19, 21, 22, 24, 25, 26, 27, 28, 29, 30, 31, 32], "might": [2, 3, 6, 8, 18, 26, 29, 32], "still": [2, 3, 7, 13, 15, 22, 29], "destin": [2, 3, 5, 15, 23, 29], "immedi": [2, 13, 24], "desir": [2, 3, 6, 9, 22, 26], "sourc": [2, 5, 7, 8, 13, 15, 16, 17, 24, 29], "actual": [2, 3, 13, 14, 19, 24], "reset": [2, 26], "veri": [2, 12, 13, 26], "short": [2, 3, 32], "empti": [2, 3, 12, 13, 22, 29, 30, 32], "code": [2, 3, 5, 6, 7, 9, 12, 13, 14, 15, 16, 17, 19, 20, 29], "reli": [2, 13, 19], "quirk": 2, "arg": [2, 3], "kwarg": [2, 3], "overload": [2, 3, 13, 14], "h": [2, 8], "own": [2, 3, 5, 6, 13, 20, 29, 31], "deep": [2, 13], "recurs": [2, 3, 19], "preserv": [2, 3, 13, 26, 29, 31], "circular": 2, "sinc": [2, 3, 7, 9, 12, 13, 14, 16, 17, 19, 20, 24, 26, 30, 32], "larg": [2, 12, 26], "amount": 2, "done": [2, 3, 8], "stop": 2, "boundari": [2, 7], "thu": [2, 19, 29], "tabl": [2, 13, 28, 29], "updat": [2, 3, 5, 13, 14, 15, 17, 21], "direct": [2, 12, 14, 17, 24], "need": [2, 3, 6, 9, 13, 17, 18, 19, 24, 26, 29, 30, 31], "note": [2, 3, 6, 14, 16, 17, 19, 21, 22, 28, 30], "incom": 2, "requir": [2, 3, 7, 8, 9, 12, 13, 14, 15, 16, 17, 24, 32], "treatment": [2, 3, 17], "see": [2, 3, 6, 8, 9, 10, 19, 22, 24, 26, 29, 30, 32], "copyforeignobject": 2, "messag": [2, 9, 14, 15, 16, 17], "improv": [2, 3, 6, 12, 13, 14, 15, 16, 17, 29, 31], "arg0": [2, 3, 4, 13], "docinfo": [2, 3, 14, 22], "deprec": [2, 3, 13, 14, 15, 16, 17, 22], "document": [2, 3, 9, 10, 12, 13, 14, 15, 16, 17, 18, 25, 26, 28, 30, 32], "brief": [2, 32], "metadata": [2, 3, 5, 12, 13, 14, 17, 26, 29, 31], "record": [2, 3, 9, 22], "about": [2, 3, 6, 9, 10, 13, 14, 19, 22, 24, 30, 31], "remov": [2, 3, 5, 7, 12, 13, 14, 15, 16, 17, 29, 32], "perspect": 2, "open_metadata": [2, 3, 22], "api": [2, 3, 11, 12, 13, 14, 15, 17, 24, 27, 29, 32], "which": [2, 3, 5, 6, 7, 9, 12, 13, 14, 15, 16, 17, 18, 19, 20, 22, 24, 26, 27, 29, 30, 31, 32], "modern": [2, 3, 14, 17], "unfortun": [2, 14, 15, 19, 20, 21, 30, 31], "complic": [2, 19, 27], "xmp": [2, 3, 5, 12, 13, 14, 17, 31], "synchron": [2, 22], "simplifi": [2, 13, 14, 22, 23], "ensur": [2, 3, 6, 9, 14, 20, 26], "like": [2, 3, 5, 6, 8, 12, 14, 16, 17, 19, 21, 24, 29, 30, 31, 32], "titl": [2, 3, 22], "delet": [2, 3, 5, 12, 13, 14, 21, 22, 26, 29], "del": [2, 12, 13, 14, 22, 29, 32], "re": [2, 3, 8, 29], "encryptioninfo": [2, 3], "flatten_annot": [2, 14], "mode": [2, 3, 9, 12, 28], "flatten": 2, "annot": [2, 3, 5, 14, 17, 26], "regular": [2, 3, 6], "markup": 2, "review": [2, 8], "highlight": 2, "proofread": [2, 14], "user": [2, 3, 5, 7, 8, 13, 14, 18, 24, 26, 28, 30, 32], "enter": [2, 22], "interact": [2, 3, 22], "field": [2, 3, 13, 22, 24], "count": [2, 5, 13, 14, 25, 32], "thei": [2, 3, 7, 8, 13, 14, 16, 17, 18, 20, 21, 24, 25, 32], "burn": 2, "fact": [2, 13, 19, 24], "were": [2, 3, 5, 7, 12, 13, 14, 15, 17, 19, 20, 21, 24, 29, 31], "onc": [2, 8, 21], "prepar": [2, 21], "longer": [2, 13, 14, 15, 16, 17, 24, 27, 29], "One": [2, 8, 25, 29], "screen": [2, 3, 28], "omit": [2, 3, 13, 32], "those": [2, 3, 5, 7, 10, 23, 29, 30], "flag": [2, 3], "noview": 2, "generate_appearance_stream": [2, 14], "acroform": 2, "exactli": [2, 21], "viewer": [2, 3, 5, 13, 20, 21, 25, 30], "free": [2, 12, 13, 21], "everi": [2, 19, 29], "subject": 2, "limit": [2, 3, 7, 13, 22, 30], "abil": [2, 12, 17], "invok": 2, "best": [2, 3, 9, 13, 19], "befor": [2, 3, 6, 12, 13, 24, 26], "expect": [2, 13, 15, 17, 26], "http": [2, 3, 6, 8, 22], "github": [2, 6, 14], "com": [2, 22], "blob": 2, "bf6b9ba1c681a6fac6d585c6262fb2778d4bb9d2": 2, "qpdfformfieldobjecthelp": 2, "hh": 2, "l216": 2, "get_object": 2, "objgen": [2, 12, 23, 29], "int": [2, 3, 4, 12, 24], "look": [2, 5, 8, 13, 14, 17, 19, 20, 26, 29, 32], "up": [2, 3, 5, 9, 14, 17, 18, 19, 29, 30, 32], "objid": 2, "gen": 2, "is_encrypt": [2, 14], "natur": [2, 19, 32], "is_linear": 2, "iff": 2, "addit": [2, 3, 7, 9, 14, 16, 19], "valid": [2, 3, 12, 13, 14, 22, 29], "make_indirect": [2, 18, 24], "indirect": [2, 5, 29, 32], "encod": [2, 3, 5, 13, 14, 17, 21, 27, 30, 31], "english": [2, 5], "4": [2, 3, 11, 18, 19, 21, 22, 23, 25, 26, 27, 29, 32], "locat": [2, 3, 6, 9, 16, 19, 25], "certain": [2, 3, 13, 14, 15, 16, 17, 32], "consult": 2, "confirm": [2, 8], "share": [2, 3, 13], "is_indirect": [2, 24], "obj": [2, 3, 12, 13, 15, 18, 21, 24, 27, 32], "python": [2, 3, 5, 7, 12, 13, 14, 15, 16, 17, 19, 20, 21, 22, 23, 24, 29, 32], "d": [2, 3, 19, 22], "__new__": 2, "static": [2, 3, 5, 30], "scratch": [2, 5, 13, 25, 27], "relat": [2, 12, 13, 14, 26], "present": [2, 3, 7, 12, 13, 17, 20, 25, 26, 31, 32], "_objectlist": [2, 19], "hex_password": 2, "ignore_xref_stream": 2, "suppress_warn": 2, "attempt_recoveri": 2, "inherit_page_attribut": 2, "access_mod": [2, 13], "accessmod": [2, 13], "allow_overwriting_input": [2, 13], "filename_or_stream": 2, "while": [2, 3, 14, 17, 21, 26, 29, 30], "undefin": [2, 17], "behavior": [2, 3, 13, 14, 15, 17, 20, 22, 26, 29], "occur": [2, 3, 13, 14, 15, 19, 22], "despit": [2, 5], "restrict": [2, 3, 5, 32], "try": [2, 6, 19], "os": 2, "servic": [2, 22], "obtain": [2, 24, 29], "exclus": [2, 3, 14, 32], "lock": [2, 7], "applic": [2, 3, 5, 6, 9, 11, 13, 19, 24, 30], "temporari": [2, 3, 12, 13, 14], "behaviour": 2, "overwrit": [2, 12, 13, 32], "persist": [2, 9], "seek": [2, 13], "readabl": [2, 13], "privat": [2, 7, 11, 14, 15, 17], "whenev": [2, 3, 4, 22, 32], "give": [2, 3, 32], "appropri": [2, 3, 6, 9, 13, 20, 24, 27], "test": [2, 3, 5, 6, 9, 12, 13, 14, 15, 16, 17, 18, 19, 21, 22, 23, 24, 27, 29, 32], "rosebud": 2, "pathlib": [2, 3, 18, 32], "binaryio": [2, 3], "seekabl": [2, 13, 32], "owner": [2, 3, 14, 27, 30, 32], "utf": [2, 3, 12, 20, 30], "verbatim": [2, 21], "pad": 2, "truncat": 2, "32": [2, 3, 6, 12, 20, 21, 29], "ascii": [2, 19, 20, 30], "maximum": [2, 3], "hex": [2, 20], "exact": 2, "kei": [2, 3, 12, 13, 21, 23, 24, 27, 32], "normal": [2, 3, 6, 19, 29, 32], "comput": [2, 3, 20], "forens": 2, "cross": 2, "warn": [2, 3, 13, 14, 15, 17, 31], "recov": [2, 13], "push": [2, 3, 19, 26], "attribut": [2, 3, 5, 12, 15, 25, 31], "individu": [2, 26, 29, 32], "decid": [2, 3, 22, 29], "select": [2, 3, 6, 7, 32], "fallback": 2, "fail": [2, 6, 12, 13, 14, 16, 26], "mmap": [2, 13], "mmap_onli": 2, "sigbu": 2, "signal": 2, "posix": [2, 3], "event": 2, "successfulli": 2, "later": [2, 14], "goe": 2, "awai": 2, "time": [2, 3, 8, 9, 13, 14, 19, 21, 24, 28, 30, 32], "recent": [2, 6, 14, 29], "especi": [2, 6], "reason": [2, 3, 8, 13, 14], "we": [2, 3, 6, 8, 9, 12, 13, 14, 15, 16, 17, 18, 19, 21, 26, 29, 32], "typeerror": [2, 14, 15], "usabl": [2, 3, 24], "filenotfounderror": [2, 12], "found": [2, 3, 17, 22], "network": 2, "assum": [2, 3, 13, 17, 32], "cach": 2, "achiev": [2, 7], "fetch": 2, "over": [2, 3, 26], "respons": 2, "request": [2, 3, 8, 13, 14, 18], "matter": [2, 3, 24], "small": [2, 13, 14], "poorli": 2, "easier": [2, 5, 8, 13, 14, 19, 30, 32], "download": [2, 6, 9], "local": [2, 6, 9, 13, 14, 15], "storag": 2, "io": [2, 6, 13, 14, 31], "bytesio": [2, 15, 31], "upload": 2, "keyword": [2, 3, 12, 13, 15, 22, 32], "argument": [2, 3, 12, 13, 14, 15, 22, 32], "mandatori": 2, "everyth": [2, 12, 26, 29], "first": [2, 3, 13, 14, 15, 19, 21, 25, 26, 29], "set_pikepdf_as_editor": 2, "update_docinfo": 2, "strict": [2, 3, 12, 14], "There": [2, 3, 20, 21, 24, 27, 29], "intend": [2, 5, 13, 16], "histor": 2, "part": [2, 3, 14, 20, 22, 29, 32], "featur": [2, 3, 5, 8, 13, 14, 17, 21, 22, 31, 32], "coordin": [2, 3, 7, 19, 21, 22], "both": [2, 3, 5, 6, 9, 13, 14, 15, 22, 25], "consist": [2, 3, 12, 13, 17, 22, 29], "atom": 2, "thread": [2, 5, 13], "disk": 2, "meta": [2, 22], "dc": [2, 3, 14, 18, 22], "dublic": 2, "core": [2, 6, 32], "descript": [2, 3, 13, 14, 18, 22, 29], "put": [2, 29], "here": [2, 3, 6, 18, 19, 22, 24, 29, 32], "produc": [2, 3, 5, 6, 16, 21, 22, 27, 30], "show": [2, 3, 5, 18, 19, 21, 32], "softwar": [2, 3, 9, 13, 26, 30, 31, 32], "metadatad": 2, "timestamp": [2, 14], "recommend": [2, 12, 19, 21, 29, 32], "documentinfo": [2, 3, 13, 14, 22], "old": [2, 6, 12, 14, 16, 19, 22], "match": [2, 3, 6, 13, 14, 15, 19, 20, 22], "correspond": [2, 3], "pdfmetadata": [2, 3, 22], "docinfo_map": 2, "nonstandard": [2, 13], "equival": [2, 3, 6, 12, 13, 20, 21, 25, 31], "aggress": [2, 5], "xml": [2, 3, 12, 13, 14, 22], "trivial": [2, 12], "incomplet": [2, 13], "skeleton": 2, "never": [2, 3, 5, 8, 12, 14, 15, 16], "proper": [2, 13, 14], "log": [2, 9, 14], "open_outlin": [2, 3, 25], "max_depth": [2, 3], "15": [2, 3, 11, 18, 21, 29, 32], "bookmark": [2, 13, 25, 29], "commit": [2, 22], "insert": [2, 3, 14, 19, 29], "outlineitem": [2, 3, 25], "intro": 2, "depth": [2, 3], "import": [2, 5, 6, 7, 8, 11, 12, 15, 17, 18, 19, 20, 21, 23, 25, 26, 27, 28, 29, 32], "written": [2, 3, 6, 7, 13, 14, 28], "mean": [2, 19, 27, 28, 29, 32], "sub": 2, "beyond": 2, "silent": [2, 3], "With": [2, 3], "loop": [2, 19], "cancel": 2, "further": [2, 6, 13, 14, 16], "node": [2, 3, 12], "particular": [2, 3, 5, 16, 20, 21, 22, 24], "leav": [2, 29, 30], "place": [2, 3, 14, 19, 21, 29], "similarli": [2, 3], "been": [2, 5, 6, 8, 12, 13, 14, 15, 16, 17], "accident": 2, "duplic": 2, "i": [2, 3, 5, 6, 19, 20, 29], "reproduc": [2, 13, 16], "owner_password_match": [2, 14, 30], "possibl": [2, 3, 6, 7, 12, 13, 15, 16, 17, 21, 24, 26, 29, 31], "pagelist": [2, 13], "pdf_version": [2, 29], "remove_unreferenced_resourc": [2, 3, 29], "referenc": [2, 3, 18, 21, 24, 32], "split": [2, 3, 5, 32], "purg": 2, "unnecessari": [2, 12, 15, 24], "entri": [2, 3, 13, 14, 22, 25, 29], "clariti": [2, 15, 16, 32], "exclud": 2, "output": [2, 5, 9, 13, 14, 15, 19, 21, 28], "convers": [2, 12, 16, 20], "discover": 2, "make": [2, 3, 5, 6, 8, 9, 12, 13, 14, 15, 17, 19, 23, 32], "suggest": [2, 12, 24], "static_id": 2, "preserve_pdfa": 2, "min_vers": [2, 13, 29], "force_vers": 2, "fix_metadata_vers": [2, 13, 22], "compress_stream": [2, 12], "stream_decode_level": [2, 12], "object_stream_mod": [2, 13], "objectstreammod": 2, "normalize_cont": 2, "qdf": [2, 12], "progress": [2, 12], "recompress_fl": 2, "modif": 2, "overwritten": 2, "permit": [2, 3, 22, 30], "same": [2, 3, 5, 6, 7, 12, 14, 15, 18, 19, 20, 21, 22, 25, 29, 30, 31], "would": [2, 3, 5, 7, 13, 14, 16, 17, 19, 21, 27, 29, 32], "corrupt": [2, 13], "lazi": [2, 13], "calcul": [2, 5, 14, 15, 19], "hash": 2, "determinist": 2, "debug": [2, 5, 14, 22], "manner": [2, 3, 9, 22, 29], "compliant": [2, 3, 6], "stricter": [2, 15], "variant": 2, "minimum": [2, 3, 12], "left": [2, 3, 19, 25, 28], "alon": 2, "second": [2, 13, 19, 26, 32], "extens": [2, 3, 5, 6, 7, 9, 10, 11, 13, 14, 15, 21, 22], "what": [2, 3, 5, 6, 15, 19, 21, 22, 32], "overrid": [2, 14, 28], "potenti": [2, 3, 12], "displai": [2, 3, 5, 18, 19, 21, 24, 28], "detail": [2, 3, 6, 24, 25, 27, 30, 31, 32], "option": [2, 3, 6, 12, 13, 14, 27, 28, 30, 31], "correct": [2, 3, 6, 8, 14, 15, 17, 19, 20, 29], "placehold": [2, 13], "pdfversion": [2, 13, 22], "regardless": [2, 19], "disabl": [2, 9, 13, 26], "prevent": [2, 13, 16], "keep": [2, 3, 7, 14, 24, 29], "wherev": [2, 32], "smallest": 2, "enabl": [2, 5, 13, 14, 31], "compress": [2, 3, 4, 5, 13, 14, 21, 27, 31], "specifi": [2, 3, 13, 17, 19, 21, 23, 26, 32], "decompress": [2, 3, 31], "non": [2, 3, 12, 13, 30], "streamdecodelevel": [2, 3], "uncompress": [2, 31], "recompress": [2, 14], "flate": [2, 4, 14], "algorithm": [2, 3, 4, 30, 32], "reformat": [2, 5], "fast": 2, "web": [2, 22], "organ": 2, "sequenti": 2, "begin": [2, 8, 13, 20, 22, 29, 32], "As": [2, 13, 18, 24, 29, 32], "drawback": 2, "tend": [2, 18], "larger": [2, 14, 16], "editor": [2, 20, 21], "program": [2, 8, 9, 17, 19, 21, 32], "back": [2, 3, 13, 14, 19, 24, 29], "callabl": 2, "callback": [2, 12], "between": [2, 3, 16, 19, 29], "100": [2, 13, 19], "sole": 2, "percentag": 2, "almost": [2, 32], "certainli": 2, "model": [2, 5, 12, 14, 17, 21, 22, 27], "altern": [2, 18], "valueerror": [2, 3, 14], "multipl": [2, 3, 8, 9, 18, 21, 26, 29, 31, 32], "continu": [2, 3, 6, 13, 19, 29, 32], "elimin": [2, 12, 13, 14], "increment": [2, 14], "show_xref_t": 2, "pretti": [2, 5, 29], "xref": 2, "trailer": 2, "section": [2, 3, 24, 25, 27, 29, 32], "speak": [2, 24], "user_password_match": [2, 14, 30], "alia": 2, "compact": 2, "third": [2, 6, 16, 22, 32], "parti": [2, 6, 16, 22], "librari": [2, 3, 7, 9, 12, 13, 16, 17, 20, 22, 30, 32], "appli": [2, 3, 13, 14, 17, 19, 22, 31, 32], "filter": [2, 3, 5, 12, 13, 19, 21, 27, 31, 32], "remain": [2, 13, 31], "lzwdecod": 2, "ascii85decod": 2, "asciihexdecod": 2, "flatedecod": [2, 13, 21], "effect": [2, 3, 9, 13, 16, 19, 21], "effici": [2, 7, 21, 31], "lossi": [2, 21], "At": [2, 13, 20], "runlengthdecod": 2, "dctdecod": [2, 27, 32], "jpeg": [2, 12, 13, 21, 27], "result": [2, 3, 8, 9, 13], "again": [2, 14, 20], "accumul": 2, "loss": [2, 17], "avoid": [2, 3, 8, 12, 13, 14, 17, 29], "cycl": 2, "mostli": 2, "low": [2, 3, 5, 19], "pdfimag": [2, 3, 12, 13, 15, 21], "r": [2, 3, 18], "extract": [2, 3, 5, 6, 12, 13, 14, 15, 17, 22, 30, 32], "modify_annot": [2, 3], "modify_assembl": [2, 3], "modify_form": [2, 3], "modify_oth": [2, 3], "print_lowr": [2, 3], "print_highr": [2, 3], "ae": [2, 3, 30, 32], "liter": [2, 3], "append": [2, 3, 13, 19, 21, 25, 29], "as_dict": 2, "_objectmap": [2, 3], "as_list": 2, "emplac": [2, 13, 14], "retain": [2, 3, 14], "parent": [2, 14, 27, 32], "particularli": [2, 31], "top": [2, 3, 13, 19, 25, 26], "link": [2, 5, 13, 16, 17], "Or": [2, 6], "assign": [2, 14, 24, 25, 29], "new_pag": 2, "know": [2, 19, 21], "optim": [2, 5, 19], "restructur": 2, "visual": [2, 13, 30, 32], "reorgan": [2, 12, 17], "n": [2, 3, 5, 19, 29, 32], "compositor": 2, "anymor": 2, "take": [2, 3, 19], "precaut": 2, "child": [2, 9], "inadvert": [2, 14], "16": [2, 11, 20, 21, 26, 29, 32], "extend": [2, 13, 14, 25, 29], "get": [2, 3, 4, 6, 8, 12, 14, 20, 26, 32], "behav": [2, 3, 12, 29, 32], "dict": [2, 3, 24, 32], "get_raw_stream_buff": 2, "protocol": [2, 3, 32], "raw": [2, 3, 21, 22, 27], "get_stream_buff": [2, 3, 13, 31], "decode_level": [2, 3], "is_owned_bi": [2, 12], "possible_own": 2, "is_rectangl": 2, "rectangl": [2, 3, 16, 19, 26], "pair": [2, 3, 26], "definit": [2, 3, 29], "necessarili": [2, 21], "usual": [2, 3, 6, 13, 14, 18, 20, 24, 26, 29], "uncommon": [2, 13], "long": [2, 9, 13], "cpu": [2, 9], "consolid": 2, "read_byt": [2, 3, 13, 18, 22, 24, 31], "read_raw_byt": [2, 31], "same_owner_a": 2, "stream_dict": [2, 14], "to_json": [2, 13], "derefer": 2, "json": [2, 13, 32], "sourceforg": 2, "net": 2, "html": [2, 6, 19, 21, 31], "ref": 2, "Not": [2, 8, 21], "wild": 2, "unrepresent": 2, "charact": [2, 5, 12, 30], "uhhhh": 2, "just": [2, 14, 19, 24, 31, 32], "reserv": 2, "serial": [2, 13, 19], "bytestr": 2, "x00": 2, "xff": [2, 21], "u": 2, "0000": [2, 19], "00ff": 2, "mojibak": 2, "unpars": [2, 12, 13, 14, 19], "resolv": [2, 3, 12, 16, 27], "rel": [2, 3, 13, 19], "defer": [2, 12, 13], "with_same_owner_a": [2, 14], "versionad": 2, "14": [2, 3, 6, 11, 18, 21, 29, 32], "wrap_in_arrai": [2, 13], "wrap": [2, 3, 8, 12, 15, 27, 32], "decode_parm": [2, 3, 12, 13], "type_check": 2, "your": [2, 6, 9, 18, 22, 26, 30, 32], "deflat": 2, "lossless": [2, 21], "png": [2, 3, 21], "tiff": [2, 3], "even": [2, 3, 7, 8, 17, 19, 21, 27, 32], "directli": [2, 3, 7, 11, 12, 13, 19, 21, 22, 24, 27, 31], "intention": 2, "index": [2, 3, 13, 14, 32], "notat": [2, 5], "former": 2, "latter": [2, 25], "dynam": [2, 6], "cl": 2, "nameon": 2, "nametwo": 2, "arbitrari": [2, 3], "payload": 2, "initi": [2, 19, 22, 28], "shall": [2, 8, 29], "length": [2, 3, 13, 14, 27, 32], "manag": [2, 3, 5, 6, 9, 13, 21, 22, 23, 32], "s1": 2, "b": [2, 3, 18, 19, 20, 21, 22], "bitspercompon": [2, 21, 27, 32], "colorspac": [2, 3, 13, 15, 21, 27, 32], "devicergb": [2, 21, 27, 32], "s2": 2, "creation": [2, 3, 5, 13, 32], "roughli": [2, 6, 25], "mini": 2, "languag": [2, 19], "line": [2, 3, 14, 19, 32], "virtual": [2, 3, 6, 9, 14], "canva": [2, 31], "along": [2, 11, 14, 16], "typic": [2, 3, 6, 13, 19, 26, 29, 32], "unlik": [2, 5, 14], "raster": [2, 5, 16, 21], "upper": [2, 17], "right": [2, 3, 6, 15, 19, 28], "four": [2, 3, 26, 32], "numer": [2, 3, 12, 29], "llx": 2, "lly": 2, "urx": 2, "uri": [2, 3], "9": [2, 3, 4, 6, 10, 11, 16, 17, 18, 19, 21, 22, 25, 29, 32], "degener": 2, "corner": [2, 19], "strictli": 2, "as_arrai": 2, "height": [2, 3, 19, 21, 22, 27, 32], "axi": [2, 3, 19], "y": [2, 3, 19], "lower_left": 2, "lower_right": 2, "upper_left": 2, "upper_right": 2, "width": [2, 3, 19, 21, 27, 32], "complet": [2, 3, 8, 14], "declar": [2, 12, 13, 16, 22], "iimag": 2, "whose": 2, "fictiti": 2, "explicitli": [2, 14, 29], "enumer": [2, 3, 29], "rang": [2, 13], "subset": [2, 19], "from_objgen": [2, 32], "arg1": 2, "find": [2, 3, 5, 21], "That": [2, 3, 8, 14, 19], "this_pag": [2, 3], "belong": [2, 3, 32], "helper": [2, 3, 5, 13, 16, 21, 31], "base": [2, 3, 5, 8, 14, 16, 19, 25], "p": [2, 3, 13, 29], "pnum": 2, "ordin": 2, "revers": [2, 5], "clear": [2, 3, 20], "l": [2, 6, 21], "pop": [2, 3, 19, 26], "last": [2, 3, 29], "objecttyp": [2, 15], "instanc": [2, 12, 14, 16], "vast": [2, 21], "major": [2, 8, 12, 14, 16, 21, 32], "isinst": [2, 3, 13, 24], "issubclass": 2, "expos": [2, 3, 17], "through": [2, 3, 9, 13, 14, 16, 20, 21, 25, 29], "_type_cod": 2, "uniniti": 2, "probabl": [2, 3, 13, 14, 22], "bug": [2, 14], "bit": [2, 3, 6, 12, 13, 16], "sign": [2, 30], "decim": [2, 3, 4, 8, 12, 13, 19, 23, 24], "inlineimag": [2, 24], "necessari": [2, 3, 9, 14, 15, 17, 20, 27, 29, 31], "combin": [2, 21, 29], "implicit": [2, 16, 27], "packag": [2, 5, 6, 7, 12, 16, 17], "interfac": [2, 3, 5, 7, 11, 12, 16, 22, 23, 29], "readthedoc": [2, 14, 17], "en": 2, "stabl": [2, 11], "__init__": [2, 3], "json_dict": 2, "schema": 2, "prognam": 2, "equal": [2, 16, 27], "run": [2, 6, 9, 13], "check_configur": 2, "configur": [2, 6, 9, 13, 15, 19], "creates_output": 2, "sort": [2, 3, 8], "encryption_statu": 2, "statu": [2, 8], "exit_cod": 2, "Their": 2, "context": [2, 3, 13, 24], "has_warn": 2, "message_prefix": 2, "prefix": [2, 3, 11, 14, 18, 21], "front": 2, "execut": [2, 9, 32], "upon": 3, "establish": [3, 19], "did": [3, 14], "objecthelp": [3, 16, 17, 24], "wrapper": [3, 5, 13, 24, 27, 32], "around": [3, 5, 8, 14, 17, 19, 24, 27, 32], "underli": [3, 7, 15, 24, 27], "add_content_token_filt": 3, "tf": 3, "content": [3, 5, 7, 12, 13, 14, 15, 17, 21, 22, 24, 26, 27, 28, 29, 31, 32], "token": [3, 5, 13], "reopen": 3, "add_overlai": [3, 16, 26], "rect": [3, 18], "push_stack": [3, 26], "shrink": 3, "expand": [3, 14], "overlai": [3, 5, 14, 29], "drawn": [3, 19, 21, 26], "trimbox": [3, 26, 27], "cropbox": 3, "mediabox": [3, 19, 27, 32], "stack": [3, 13, 19, 26], "offici": [3, 13, 22], "toler": 3, "excess": 3, "caus": [3, 9, 12, 13, 14, 16, 17], "problem": [3, 13, 14, 17, 20, 29], "writer": [3, 8, 14], "fit": [3, 25], "aspect": [3, 26], "ratio": [3, 26], "previous": [3, 12, 13, 14, 15, 17], "add_resourc": [3, 14], "res_typ": 3, "replace_exist": 3, "extgstat": 3, "pattern": [3, 19], "shade": 3, "font": [3, 19], "random": [3, 12, 14, 16], "enough": [3, 13, 29], "global": [3, 4, 7, 14], "uniqu": 3, "namespac": [3, 12, 17], "im": 3, "mutual": 3, "resource_nam": 3, "formxobj": 3, "add_underlai": [3, 16, 26], "underlai": [3, 5, 29], "beneath": 3, "overdrawn": [3, 26], "partial": 3, "underneath": [3, 26], "issu": [3, 8, 12, 13, 14, 15, 16, 17, 20, 30], "wrong": [3, 6, 13, 14, 15], "as_form_xobject": [3, 26], "handle_transform": 3, "thumbnail": [3, 26, 28], "shallow": [3, 13, 14, 29], "anywher": 3, "matrix": [3, 19, 26], "rotat": [3, 5, 19], "scale": [3, 16, 19, 21, 31], "userunit": 3, "calc_form_xobject_plac": [3, 15, 26], "formx": 3, "invert_transform": 3, "allow_shrink": 3, "allow_expand": 3, "segment": 3, "placement": [3, 26], "full": [3, 7, 19, 21, 22, 28, 32], "dimens": [3, 19, 21, 26], "occupi": 3, "contents_add": 3, "prepend": [3, 6, 19], "contents_coalesc": 3, "concaten": [3, 5, 26], "spot": 3, "middl": 3, "confus": [3, 21, 29], "externalize_inline_imag": 3, "min_siz": 3, "extern": [3, 14], "nest": [3, 25], "get_filtered_cont": 3, "rather": [3, 6, 8, 9, 13, 14, 15, 26, 29], "account": [3, 13, 19], "prefac": [3, 29], "roman": [3, 29], "ii": [3, 29], "iii": [3, 29], "appendix": [3, 29], "guarante": [3, 29], "ordinari": [3, 14], "rule": [3, 14, 24, 27], "parse_cont": 3, "streampars": [3, 15], "alter": [3, 5], "elsewher": [3, 22, 27, 31], "walk": 3, "track": [3, 19, 24], "somewher": 3, "Then": [3, 19], "unus": 3, "across": [3, 7, 13, 26], "angl": [3, 32], "90": 3, "clockwis": 3, "degre": [3, 5], "pdfmatrix": [3, 19], "matric": 3, "3x3": 3, "summar": [3, 28], "shorthand": [3, 19, 32], "f": [3, 14, 19, 29], "column": [3, 28], "homogen": 3, "row": 3, "vr": 3, "textbook": 3, "vc": [3, 6], "meaning": 3, "mathemat": 3, "immut": 3, "six": [3, 19], "activ": [3, 6], "affin": 3, "translat": [3, 13, 19], "express": [3, 24, 32], "skew": 3, "ident": [3, 14, 16, 20, 29, 30], "construct": [3, 5, 15, 24, 32], "angle_degrees_ccw": 3, "irregular": 3, "difficult": [3, 5, 13, 19], "introduc": [3, 13], "address": [3, 29], "difficulti": 3, "spirit": 3, "pillow": [3, 16, 17, 21, 32], "as_pil_imag": [3, 21], "bits_per_compon": 3, "per": [3, 16], "compon": [3, 16], "decodeparm": [3, 12, 13, 14, 17], "extract_to": [3, 13, 21], "fileprefix": [3, 13, 21], "transcod": [3, 21], "known": [3, 5, 6, 13, 15, 19, 32], "until": [3, 16, 24, 32], "renam": [3, 12, 15, 25], "jpg": [3, 21], "bytes_io": 3, "tmp": 3, "image00": 3, "writabl": [3, 21], "filter_decodeparm": 3, "lot": [3, 8, 12, 13, 15, 21], "concern": [3, 14], "absent": 3, "filternam": 3, "decodeparmnam": 3, "pixel": [3, 13, 19, 21], "icc": [3, 13], "pil": [3, 13, 14, 21], "imagecm": 3, "imagecmsprofil": 3, "profil": [3, 5, 13], "image_mask": 3, "mask": [3, 12, 21], "color": [3, 13, 21], "palett": [3, 12, 13], "is_device_n": 3, "devicen": [3, 15], "is_inlin": 3, "pdfinlineimag": 3, "is_separ": 3, "palettedata": 3, "unencod": 3, "howev": [3, 5, 21, 22, 24, 25], "image_data": 3, "image_object": 3, "pikepdf_mark": 3, "sync_docinfo": 3, "overwrite_invalid_xml": 3, "newer": [3, 6, 12, 13, 14, 17, 18], "platform": [3, 5, 8, 13, 14, 17, 18, 22], "documentinform": 3, "primarili": [3, 8], "kept": [3, 14], "purl": [3, 22], "org": [3, 8, 22], "sever": [3, 5, 6, 12, 13, 14, 16, 17, 24, 26, 31], "common": [3, 5, 13, 14, 15, 19, 22, 29], "regist": [3, 13, 16, 20], "load_from_docinfo": [3, 13, 22], "delete_miss": 3, "raise_failur": 3, "popul": [3, 13], "failur": [3, 12, 13, 14, 17], "few": [3, 6, 12, 13, 14, 17, 24], "approxim": 3, "pdfa_statu": [3, 22], "conform": [3, 5, 14], "claim": [3, 22], "independ": 3, "verifi": [3, 22], "verapdf": [3, 12, 14, 22], "truli": 3, "1a": 3, "1b": [3, 22], "2a": 3, "2b": 3, "2u": 3, "3a": 3, "3b": 3, "3u": 3, "pdfx_statu": 3, "secur": [3, 5, 14], "handler": [3, 32], "choos": 3, "highest": 3, "rc4": 3, "grant": 3, "decrypt": 3, "control": [3, 18, 26, 28], "reader": [3, 14], "anyon": [3, 30], "maintain": [3, 8, 16, 17, 19], "intuit": 3, "12": [3, 6, 11, 18, 21, 22, 25, 29, 32], "page_loc": 3, "action": [3, 6, 14, 18, 25], "bottom": [3, 19], "zoom": [3, 5], "click": [3, 18], "pageloc": 3, "supplement": [3, 10], "simpl": [3, 19, 21, 23, 24, 32], "fith": 3, "Will": 3, "dure": 3, "float": [3, 4, 13, 24], "viewport": 3, "neighbor": 3, "xyz": [3, 23], "pagelocationentri": 3, "classmethod": 3, "from_dictionary_object": 3, "to_dictionary_object": 3, "create_new": 3, "peopl": [3, 19, 30], "who": [3, 5, 14, 30], "suffici": [3, 13], "person": [3, 30], "develop": [3, 5, 6, 8, 9, 14, 30, 31], "unencrypt": [3, 15, 32], "arrang": 3, "fill": [3, 26], "out": [3, 5, 13, 18, 19, 21, 22, 23, 27, 29, 32], "high": 3, "resolut": [3, 5, 21], "encryptionmethod": 3, "unknown": 3, "obsolet": [3, 14, 16], "aesv3": [3, 10], "adob": [3, 10, 18, 22], "iso": [3, 10], "32000": [3, 10], "128": 3, "256": [3, 32], "deriv": [3, 16, 24], "encdict": 3, "due": [3, 9, 12, 13, 14], "overlap": 3, "revis": [3, 14], "v": 3, "encryption_kei": 3, "file_method": 3, "stream_method": 3, "string_method": 3, "user_password": 3, "unicod": [3, 12, 13, 14, 19], "underlin": 3, "widget": [3, 14], "redact": 3, "3d": 3, "sound": [3, 5], "video": 3, "clip": 3, "terminolog": [3, 31], "appearance_dict": 3, "appearance_st": 3, "state": [3, 14, 19], "checkbox": 3, "radio": 3, "button": 3, "On": [3, 9, 19], "off": [3, 17], "get_appearance_stream": 3, "rollov": 3, "down": [3, 19], "pass": [3, 12, 22, 24, 25], "whether": [3, 14, 20, 24, 32], "get_page_content_for_appear": 3, "required_flag": 3, "forbidden_flag": 3, "mainli": [3, 7, 17], "Its": [3, 5], "subtyp": [3, 18, 27, 32], "abc": 3, "mutablemap": 3, "attachedfilespec": [3, 18], "k": [3, 13, 23], "els": [3, 26, 29], "keyerror": 3, "popitem": 3, "setdefault": 3, "lack": [3, 12, 14], "target": [3, 5, 16, 24, 25, 26, 29], "get_fil": [3, 18], "fs": [3, 18], "txt": [3, 9, 14, 18], "from_filepath": [3, 18], "spreadsheet": 3, "xlsx": 3, "concept": [3, 13], "fork": [3, 14], "system": [3, 9, 12, 13, 14, 17, 19, 32], "theori": 3, "ought": [3, 13, 14, 17], "perhap": [3, 8, 29], "window": [3, 9, 12, 13, 14, 18, 20, 28, 32], "arguabl": 3, "deal": [3, 12], "get_all_filenam": 3, "mime_typ": [3, 18], "creation_d": 3, "mod_dat": 3, "spec": [3, 14], "shown": [3, 8, 18, 25, 29], "help": [3, 5, 9, 14, 21, 22, 29, 32], "date": [3, 13, 14], "main": [3, 5, 18, 25, 32], "prioriti": 3, "uf": 3, "unix": 3, "mac": 3, "mime": 3, "infer": 3, "holdov": 3, "pre": 3, "era": 3, "punctuat": 3, "forbidden": [3, 13], "attachedfil": [3, 18], "primari": 3, "md5": 3, "checksum": 3, "creator": [3, 14, 21, 22], "nametre": [3, 15, 17, 23], "tree": [3, 5, 13, 15, 17, 32], "confusingli": 3, "dictmap": 3, "intern": [3, 5, 8, 12, 13, 15, 16, 24, 29], "fairli": [3, 19, 22, 27, 29], "mani": [3, 5, 7, 8, 9, 13, 14, 15, 16, 17, 22, 23, 24, 27, 30, 32], "repair": [3, 5], "auto_repair": 3, "catalog": [3, 24, 32], "dest": [3, 23, 25], "nt": [3, 23], "numbertre": [3, 17], "spars": 3, "much": [3, 5, 7, 8, 14, 26, 32], "thing": [3, 5, 12, 14, 15, 20, 29, 30], "face": 3, "pagelabel": [3, 29], "lowercas": 3, "iv": 3, "tune": 4, "get_decimal_precis": 4, "digit": [4, 5, 13, 23], "set_decimal_precis": 4, "set_flate_compression_level": 4, "increas": [4, 14], "northern": 5, "pike": [5, 11, 32], "esox": 5, "luciu": 5, "py": [5, 6, 8, 9, 13, 14], "pyqpdf": 5, "dyslexia": 5, "fun": [5, 8], "But": [5, 19, 29], "sai": [5, 6, 19, 24, 32], "loud": 5, "abus": 5, "thank": [5, 13, 14, 16, 17], "180": 5, "my_pdf": 5, "knowledg": 5, "familiar": [5, 13], "build": [5, 12, 13, 14, 15, 16, 17], "app": 5, "fish": [5, 6, 8], "tough": 5, "hard": [5, 20], "fight": 5, "predat": 5, "merg": [5, 24, 25, 26, 32], "rest": 5, "reposit": 5, "acrobat": [5, 10, 13, 18], "downsampl": 5, "dedupl": 5, "charg": 5, "scan": [5, 21, 29], "project": [5, 6, 13], "materi": [5, 29], "meet": 5, "purpos": [5, 9], "pikemen": 5, "brace": 5, "calvari": 5, "carri": 5, "pymupdf": 5, "pypdfium2": 5, "poppler": 5, "ghostscript": [5, 22], "paper": 5, "captur": [5, 13, 18, 26], "epub": 5, "xp": 5, "djvu": 5, "postscript": [5, 19], "mupdf": 5, "reportlab": [5, 19], "pypdf2": 5, "pdfrw": 5, "pure": [5, 14, 19, 24], "design": [5, 9, 17], "prior": 5, "wheel": [5, 12, 13, 14, 15, 16, 17], "made": [5, 13, 14, 16, 17, 29], "leverag": 5, "matur": 5, "capabl": [5, 6, 22], "damag": 5, "impur": 5, "proud": 5, "impress": 5, "agpl": 5, "licens": [5, 8, 10, 13, 14, 17], "linux": [5, 9, 12, 13, 14, 16, 17], "bsd": 5, "distribut": [5, 17], "author": [5, 14], "ocrmypdf": [5, 14, 22], "inspect": [5, 20, 21, 27], "graft": 5, "ocr": [5, 22], "layer": [5, 21], "pdfinfo": 5, "suit": [5, 9, 12, 13, 14, 17, 22], "instal": [5, 9, 14, 16, 17], "basic": [5, 26], "freebsd": [5, 13, 14], "pypy3": [5, 14], "tutori": [5, 29], "repr": [5, 15, 24], "next": [5, 19, 21], "step": [5, 6, 13, 14, 31], "assembl": [5, 7, 25, 32], "box": [5, 13], "lifecycl": 5, "o": [5, 9, 19, 20], "robustli": 5, "watermark": [5, 14, 29, 32], "pdfdocencod": [5, 13], "codec": [5, 13, 14], "notic": 5, "info": 5, "signatur": [5, 12, 14], "certif": 5, "job": [5, 9, 17, 21], "parser": [5, 19, 21], "architectur": 5, "safeti": 5, "contribut": [5, 13], "guidelin": 5, "big": [5, 19], "style": [5, 12, 15, 17, 19, 21], "guid": [5, 9], "port": [5, 13], "trace": 5, "gdb": 5, "compil": [5, 6, 13, 14, 16], "against": [5, 13, 14, 16, 17, 19], "valgrind": 5, "pymemtrac": 5, "maco": [6, 9, 13, 14, 16, 17, 18], "x64": 6, "pip": [6, 9, 14], "environ": [6, 9, 17], "ship": 6, "18": [6, 11, 21, 29, 32], "04": 6, "upgrad": [6, 14], "wget": 6, "bootstrap": 6, "pypa": 6, "python3": [6, 16], "20": [6, 21, 29, 32], "pypi": [6, 14, 16, 17], "intel": 6, "appl": [6, 14, 16, 17], "silicon": [6, 14, 16, 17], "manylinux2014": [6, 16], "aarch64": [6, 17], "arm64": 6, "musllinux": 6, "lag": 6, "dai": 6, "wait": 6, "better": [6, 13, 14, 17, 19, 22, 26, 27, 31, 32], "notabl": [6, 13, 14], "17": [6, 11, 16, 21, 29, 32], "libjpeg": 6, "zlib": [6, 21], "behind": [6, 7], "dnf": 6, "apk": 6, "py3": 6, "pkg": 6, "py38": 6, "someth": [6, 12], "lxml": [6, 12, 13], "pybind11": [6, 7, 8, 12, 13, 14, 15, 16, 17], "procedur": [6, 13, 21], "13": [6, 11, 18, 21, 29, 32], "msvc": 6, "19": [6, 11, 21, 22, 29, 32], "header": [6, 8, 14, 17, 21], "repolog": [6, 8], "bundl": 6, "built": [6, 13, 14, 15, 16], "linker": [6, 16], "precis": [6, 13, 19, 24, 26], "abi": [6, 13], "setup": [6, 8, 9, 13, 14, 17], "pick": [6, 13], "variabl": [6, 7, 8, 9, 13, 14, 17, 19], "cc": 6, "cxx": 6, "redirect": 6, "throw": [6, 14, 31], "importerror": 6, "miss": [6, 12, 13, 14, 17, 32], "symbol": [6, 9, 14], "ones": 6, "brew": 6, "clone": 6, "repositori": 6, "setuptool": [6, 17], "wish": [6, 19], "dev": 6, "usr": [6, 9], "directori": [6, 13, 16, 17], "env": [6, 9], "cxxflag": [6, 9], "ldflag": 6, "lib": [6, 9], "bin": 6, "msvc64": 6, "zip": 6, "our": [6, 8, 13, 14, 15, 16, 19, 31, 32], "integr": [6, 9, 13, 16, 32], "script": [6, 9, 13, 15], "appveyor": [6, 12], "yml": 6, "pain": 6, "precompil": 6, "dll": 6, "mix": [6, 7], "mingw": 6, "detect": [6, 13, 26], "forc": [6, 9, 14, 20], "prompt": [6, 18], "vs140comntool": 6, "vcvarsal": 6, "bat": 6, "distutils_use_sdk": 6, "mssdk": 6, "microsoft": [6, 13], "runtim": [6, 13, 16], "abov": [6, 9, 19, 24, 25, 29], "src": [6, 9, 21, 25, 29], "folder": 6, "registri": 6, "machin": [6, 14, 15], "abl": 6, "qpdf_source_tre": [6, 9], "ld_library_path": [6, 9], "libqpdfxx": 6, "dyld_library_path": [6, 9], "tell": [6, 14, 18, 25], "custom": [6, 14, 17, 29], "alongsid": 6, "latest": 6, "yaml": 6, "sphinx": [6, 17], "regener": 6, "doc": [6, 14], "cd": [6, 9], "cibuildwheel": [6, 15, 17], "64": 6, "cpython": [6, 9], "benefit": 6, "nativ": [6, 9], "bind": [7, 8, 9, 13, 14, 15, 17], "evalu": [7, 13], "cython": 7, "cffi": 7, "swig": 7, "solut": 7, "clean": [7, 13, 19], "modul": [7, 9, 11, 14, 15, 16, 17, 31], "underscor": [7, 11], "although": [7, 21, 31], "situat": [7, 13, 14, 24, 31], "gil": [7, 13, 16, 17], "safe": [7, 13], "gain": 7, "pickl": 7, "marshal": 7, "multiprocess": [7, 14], "send": [7, 24], "parallel": [7, 14], "divid": 7, "worker": 7, "technic": 7, "held": [7, 16, 17, 24], "welcom": 8, "pleas": 8, "discuss": [8, 29], "propos": 8, "idea": [8, 9], "contempl": 8, "half": [8, 19], "branch": [8, 12], "pep8": 8, "black": [8, 13], "isort": 8, "pyproject": [8, 17], "toml": [8, 16, 17], "cfg": [8, 14], "pull": 8, "doubl": 8, "quot": 8, "clang": [8, 13, 14], "formatt": 8, "imperfect": 8, "eagerli": 8, "await": 8, "dangl": [8, 14], "parenthesi": 8, "llvm": 8, "d33029": 8, "snake_cas": 8, "camelcas": 8, "convent": [8, 19, 29, 32], "closer": 8, "auto": 8, "module_": 8, "attr": 8, "though": 8, "don": [8, 14, 22, 24], "t": [8, 12, 14, 22, 24, 29], "tradit": 8, "cpp": 8, "repetit": 8, "inl": 8, "suffix": [8, 13], "inclus": [8, 16], "raii": 8, "nake": 8, "pointer": [8, 24], "stl": 8, "std": [8, 14], "char": 8, "pragma": 8, "guard": 8, "silli": 8, "ifdef": 8, "25": [8, 13, 21, 29, 32], "year": [8, 13], "come": [8, 31], "debian": [8, 10], "red": 8, "hat": 8, "life": [8, 13, 14, 16], "downstream": [8, 17], "spell": 8, "capit": 8, "sentenc": 8, "period": 8, "allus": 8, "energet": 8, "mildli": 8, "amus": 8, "tc_scope": 9, "tc_filenam": 9, "your_log_fil": 9, "libqpdf_log": 9, "my_pikepdf_script": 9, "simultan": 9, "cflag": [9, 17], "o0": 9, "cppflag": 9, "j": 9, "build_ext": 9, "inplac": 9, "ll": [9, 32], "protect": [9, 13, 30, 32], "install_name_tool": 9, "dylib": 9, "debugg": 9, "lldb": 9, "cprofil": 9, "fine": 9, "explor": [9, 32], "spy": 9, "spent": 9, "demangl": 9, "happili": 9, "recompil": 9, "export": [9, 12, 13], "speedscop": 9, "svg": [9, 31], "illeg": [9, 13], "templat": 9, "npm": 9, "sudo": 9, "some_script": 9, "browser": 9, "pytest": [9, 13, 14], "n0": 9, "usag": [9, 13], "diagnos": 9, "leak": [9, 17], "2008": 10, "basevers": 10, "extensionlevel": 10, "june": 10, "copyright": 10, "polici": 11, "product": [11, 29], "v5": 11, "v4": 11, "v3": 11, "v2": [11, 12, 13], "v1": 11, "v0": 11, "segfault": 12, "canon": 12, "appar": 12, "neg": [12, 13], "commonli": [12, 20], "ns1": 12, "etc": [12, 14, 15, 28], "skip": [12, 13, 29], "wouldn": 12, "timezon": [12, 14], "scalar": [12, 22, 24], "defusedxml": [12, 13], "toolkit": [12, 22], "libexempi": [12, 22], "multibyt": 12, "had": [12, 13, 14, 16], "themselv": [12, 21, 32], "pdfobj": 12, "beta": [12, 14], "stream_data_mod": 12, "drop": [12, 13, 16], "favor": 12, "occasion": 12, "qpdffakenam": 12, "vendor": 12, "jpeg2000": [12, 21], "subtre": 12, "attributenam": 12, "cmyk": 12, "grayscal": [12, 21], "rgb": 12, "yuv": 12, "properli": [12, 22], "syntax": [12, 14, 15, 22, 32], "foo": [12, 14], "temporarili": 12, "master": 12, "unreleas": [12, 13], "remove_unneeded_resourc": 12, "smaller": [12, 13], "catch": 12, "unparse_resolv": 12, "ipython": [12, 14, 21, 32], "jupyt": [12, 21, 32], "slice": [12, 29, 32], "began": 12, "notebook": [12, 32], "yet": [12, 13, 16], "setter": 12, "anywai": [12, 20], "check_own": 12, "get_object_id": 12, "public": 12, "becom": [12, 13], "submodul": 12, "hold": [12, 13, 18, 27, 29], "eas": [12, 13], "oppos": [12, 13], "upstream": 13, "stabil": 13, "unsupport": [13, 16], "switch": [13, 16], "rdf": [13, 22], "effort": 13, "learn": 13, "ccitt": [13, 17], "cherri": 13, "workaround": [13, 16, 17], "pr": 13, "2223": 13, "coverag": [13, 14, 17], "accomplish": 13, "hit": 13, "junk": 13, "crash": 13, "114": 13, "freed": 13, "jbig2": [13, 14, 16, 17], "oldest": 13, "ci": [13, 14], "109": 13, "iamg": 13, "108": 13, "opt": [13, 14], "consider": 13, "jbig2dec": [13, 14], "side": [13, 16], "interfer": 13, "stdout": 13, "unexpect": 13, "tag": [13, 17, 21, 31], "reach": [13, 16], "septemb": 13, "2020": 13, "moment": 13, "9beta": 13, "fedora": 13, "33": [13, 29], "regress": 13, "fulli": [13, 32], "exceed": 13, "round": 13, "refus": 13, "nan": 13, "infin": 13, "futur": 13, "clarifi": [13, 31], "area": 13, "matthia": 13, "erll": 13, "hypothesi": [13, 16], "cygwin": [13, 14], "jhgarrison": 13, "defens": 13, "101": 13, "delint": 13, "minor": [13, 14, 17], "randomli": [13, 16], "deadlin": 13, "nonfre": 13, "rebuild": [13, 14, 16, 17], "87": 13, "86": 13, "80": 13, "lambi": 13, "broken": [13, 14, 17], "maxwel": 13, "packet": 13, "recoveri": 13, "assist": 13, "confid": 13, "essenti": 13, "apart": 13, "fluff": 13, "71": 13, "portabl": 13, "patch": 13, "manylinux2010": [13, 16], "deploi": 13, "infrastructur": 13, "migrat": 13, "azur": [13, 14], "pipelin": [13, 14], "ccittfaxdecod": 13, "g4": 13, "encodedbytealign": 13, "speckl": 13, "affect": [13, 14, 15, 17, 25, 29], "rare": [13, 14, 17, 18], "ambigu": 13, "adjust": [13, 15, 16, 17, 22], "alpin": 13, "musl": 13, "libc": 13, "struct": 13, "break": [13, 14, 19, 29], "metaprogram": 13, "mention": [13, 16, 24, 27], "logic": 13, "manylinux1": 13, "emb": [13, 18, 21], "reflect": [13, 24], "pdfdoc": [13, 14, 17, 20], "deadlock": 13, "27": [13, 21, 29, 32], "reject": 13, "absenc": 13, "harden": 13, "revert": 13, "intermedi": 13, "filepath": 13, "suppress": [13, 22], "colortransform": 13, "pink": 13, "variou": [13, 24, 29, 32], "datetim": 13, "strftime": 13, "augment": 13, "inspector": 13, "understand": 13, "imghdr": 13, "autoformat": [13, 14], "xmpmeta": [13, 22], "rebuilt": [13, 17], "proven": 13, "synthet": 13, "entiti": [13, 14], "escap": 13, "nul": 13, "linter": 14, "tighten": 14, "mara004": 14, "unicodeencodeerror": 14, "identifi": [14, 22, 23], "regebro": 14, "218": 14, "kraptor": 14, "219": 14, "hint": [14, 16], "amend": 14, "makefil": [14, 17], "No": 14, "composit": [14, 26], "solv": 14, "task": 14, "involv": [14, 17, 24, 31], "footer": 14, "42": 14, "213": 14, "214": 14, "extra": 14, "isol": 14, "imbu": 14, "stringstream": 14, "happen": [14, 19, 21, 27], "x86_64": 14, "abbrevi": 14, "problemat": 14, "lead": 14, "poor": 14, "typo": [14, 17, 31], "precommit": 14, "ongo": 14, "unreach": 14, "160": 14, "tri": 14, "cmd_class": 14, "cmdclass": 14, "go": [14, 25], "m": [14, 16], "holger": [14, 16], "xxe": 14, "vulner": 14, "eric": 14, "therond": 14, "sonarsourc": 14, "cve": 14, "2021": [14, 16], "29421": 14, "expans": 14, "__repr__": 14, "_method": 14, "_repr_mimebundle_": 14, "regard": 14, "strang": 14, "provabl": 14, "demo": 14, "readm": [14, 17, 18], "md": [14, 18], "publish": [14, 17], "codecov": 14, "_roundtrip": 14, "post1": 14, "transit": [14, 17], "post": 14, "subtl": 14, "post2": 14, "grow": 14, "aw": 14, "lambda": 14, "strip": 14, "mitig": [14, 30], "broke": 14, "ever": 14, "promis": 14, "explicit": 14, "unown": 14, "surrog": 14, "behalf": 14, "hopefulli": 14, "150": 14, "143": 14, "mypi": 14, "mojav": 14, "sens": 14, "namedtupl": 14, "strong": [14, 30], "assumpt": 14, "superclass": 14, "__eq__": [14, 17], "notimpl": [14, 17], "uncompar": 14, "pdfjpximag": 14, "significantli": [14, 23], "258": 15, "261": 15, "refactor": [15, 16, 17], "idiom": [15, 24], "strongli": [15, 19], "page_contents_": 15, "contents_": 15, "_attach": 15, "_process": 15, "counterpart": 15, "examin": [15, 32], "209": 15, "printer": 15, "237": 15, "232": 15, "constructor": [15, 32], "gcc": 16, "jerkenbilt": 16, "dead": 16, "vs": 16, "tightli": 16, "tomli": 16, "instabl": 16, "rwgk": 16, "relev": [16, 22], "qulog": 16, "distutil": 16, "sjahu": 16, "277": 16, "bordaigorl": 16, "276": 16, "282": 16, "271": 16, "compar": 16, "chri": 16, "lamb": 16, "sean": 16, "whitton": 16, "cherryblossom000": 16, "soon": 16, "backport": 16, "critic": 16, "decemb": 16, "photometri": 17, "blackis1": 17, "seem": 17, "plan": 17, "v6": 17, "inconsist": 17, "willanglei": 17, "sdist": 17, "cmake": 17, "qpdf_": 17, "pabloalexis611": 17, "spdx": [17, 18], "throughout": 17, "chore": 17, "qpdfjob": 17, "instanti": 17, "scm": 17, "encount": 17, "299": 17, "git": 17, "archiv": 17, "roll": 17, "testabl": 17, "pluggabl": 17, "setuptools_scm": 17, "359": 17, "unhelp": 17, "attemp": 17, "341": 17, "349": 17, "bound": [17, 27], "panel": [17, 18, 28], "pkg_resourc": 17, "importlib": 17, "backward": [17, 22, 29], "importlib_metadata": 17, "317": 17, "manylinux": 17, "328": 17, "pep": 17, "621": 17, "323": 17, "homebrew": 17, "turn": 17, "shim": 17, "322": 17, "conjunct": 17, "search": 17, "quicker": 17, "lookup": 17, "quick": 18, "let": [18, 19, 22, 29, 31, 32], "fourpag": [18, 29, 32], "filespec": 18, "50": [18, 19, 27, 32], "filecopyrighttext": 18, "2022": 18, "jame": 18, "barlow": 18, "memfilespec": 18, "plain": 18, "alphabet": 18, "pagemod": 18, "useattach": [18, 28], "pane": 18, "honor": 18, "icon": 18, "pushpin": 18, "fileattach": 18, "graphpushpin": 18, "twice": 18, "noth": 19, "thought": [19, 24], "loos": 19, "sometim": [19, 21, 24, 25, 31], "mistakenli": 19, "grammar": 19, "condit": 19, "image1": 19, "extrem": 19, "congress": [19, 21, 27, 29, 32], "200": [19, 27, 32], "304": [19, 27, 32], "im0": [19, 21, 27, 32], "contriv": 19, "ctm": 19, "figur": 19, "answer": 19, "35": [19, 27, 29], "mm": [19, 27], "substitut": 19, "paint": [19, 21], "center": [19, 22, 26], "reduc": [19, 21], "rewrit": 19, "new_matrix": 19, "152": 19, "76": 19, "nail": 19, "quadrant": 19, "cartesian": 19, "graph": [19, 29], "flip": 19, "new_content_stream": 19, "n100": 19, "nq": 19, "illustr": 19, "simplic": 19, "offset": 19, "And": 19, "often": [19, 24, 31], "predict": 19, "total": 19, "guess": [19, 29, 30], "glyph": 19, "transpar": [19, 20, 21, 24], "dump": 19, "perfectli": 19, "legal": 19, "unconvent": 19, "scrape": 19, "pdfminer": 19, "three": [20, 25, 31], "scienc": 20, "\u0499": 20, "\u02b9\u02b9": 20, "\u02b9": 20, "marseil": 20, "folog": 20, "circumst": [20, 22], "126": 20, "0x20": 20, "0x7e": 20, "surround": 20, "parenthes": 20, "hello": 20, "world": 20, "x81": 20, "win": 20, "fortun": [20, 31], "quit": [20, 32], "pdfdoc_pikepdf": 20, "obscur": 20, "winansiencod": 20, "1252": 20, "cp1252": 20, "macromanencod": 20, "macroman": 20, "repeat": 21, "facil": 21, "img2pdf": 21, "pdf2img": 21, "crop": 21, "page1": [21, 27, 32], "rawimag": 21, "backend": 21, "1000": [21, 25, 27, 32], "1520": [21, 27, 32], "straightforward": 21, "qualiti": 21, "jpegimageplugin": 21, "jpegimagefil": 21, "img": 21, "art": 21, "overdraw": 21, "togeth": [21, 25, 31], "pillowimag": 21, "resiz": 21, "tobyt": 21, "devicegrai": 21, "occurr": 21, "easi": [21, 31, 32], "1x1": 21, "imagemask": 21, "sandwich": [21, 22, 29], "21": [21, 22, 29, 32], "22": [21, 22, 29, 32], "image_nam": 21, "23": [21, 29, 32], "new_imag": 21, "24": [21, 29, 32], "26": [21, 29, 32], "28": [21, 29], "compound": [22, 23, 24], "quantiti": [22, 24], "creatortool": 22, "tesseract": 22, "05": 22, "01": 22, "t02": 22, "mere": 22, "pdfen": 22, "kind": 22, "valuabl": 22, "xpacket": 22, "w5m0mpcehihzreszntczkc9d": 22, "xmln": 22, "ns": 22, "www": 22, "w3": 22, "1999": 22, "02": 22, "seq": 22, "li": 22, "consortium": 22, "xap": 22, "builder": 22, "created": 22, "2015": 22, "03": 22, "10t17": 22, "00": 22, "modifyd": 22, "pdfaid": 22, "aiim": 22, "pdfa": 22, "w": 22, "worth": 22, "troubl": 22, "live": 22, "touch": 22, "creationd": 22, "20170911132748": 22, "07": 22, "moddat": 22, "gpl": 22, "compos": [23, 30], "primit": 23, "url": 23, "javascript": 23, "89": 23, "29": [23, 29], "cover": 24, "qpdfobjecthandl": 24, "importantli": 24, "shouldn": 24, "simplest": [24, 25], "stand": [24, 29], "offer": [24, 30], "superset": 24, "eafp": 24, "partli": 24, "catalog_nam": 24, "neatli": 24, "great": 24, "came": 24, "hundr": 24, "inner": 24, "hide": 24, "indirectli": 24, "dereferenc": 24, "tediou": 24, "asid": [25, 32], "navig": 25, "1st": 25, "3rd": 25, "9th": 25, "document_with_outlin": 25, "glob": [25, 29], "page_count": 25, "oi": 25, "len": [25, 29, 32], "move": 25, "fitb": 25, "make_page_destin": 25, "children": 25, "main_item": 25, "slide": 26, "onto": 26, "destination_pag": 26, "300": 26, "page1_with_page2_thumbnail": 26, "hyperlink": [26, 29], "encapsul": 26, "align": 26, "ideal": 27, "good": 27, "192956": [27, 32], "dct": 27, "pt": 27, "impli": 27, "harmless": 27, "trim": 27, "media": 27, "layout": 28, "singlepag": 28, "fullscreen": 28, "below": 28, "onecolumn": 28, "twocolumnleft": 28, "odd": 28, "twocolumnright": 28, "twopageleft": 28, "twopageright": 28, "usenon": 28, "neither": 28, "nor": 28, "visibl": 28, "useoutlin": 28, "usethumb": 28, "menu": 28, "bar": 28, "useoc": 28, "breviti": 29, "dst": 29, "02d": 29, "transfer": 29, "sampl": [29, 32], "sophist": 29, "unreferenc": 29, "chose": 29, "max": 29, "suppos": [29, 30], "easili": 29, "mayb": 29, "scanner": 29, "nice": 29, "isn": 29, "bump": 29, "ahead": 29, "therefor": 29, "think": 29, "demolish": 29, "interior": 29, "hous": 29, "30": 29, "31": 29, "donor": 29, "34": 29, "36": 29, "accessor": 29, "37": 29, "38": 29, "39": 29, "scheme": 29, "introductori": 29, "bodi": 29, "arab": 29, "40": 29, "parlanc": 29, "wide": [30, 32], "theatr": 30, "everyon": 30, "useless": 30, "bypass": 30, "crack": 30, "motiv": 30, "unlimit": 30, "chanc": 30, "signific": 30, "weak": 30, "prove": 30, "widest": 30, "unclear": 30, "regularli": 31, "varieti": 31, "term": 31, "taxonomi": 31, "realli": 31, "fillabl": 31, "noteworthi": 31, "saniti": 31, "page_contents_coalesc": 31, "filelike_object": 31, "introduct": 32, "orient": 32, "paradigm": 32, "topic": 32, "contrast": 32, "cleverli": 32, "new_pdf": 32, "cours": 32, "conflict": 32, "uppercas": 32, "fundament": 32, "rich": 32, "suffic": 32, "attrdict": 32, "kid": 32, "obj_page1": 32, "bracket": 32, "eval": 32, "arbitrarili": 32, "chosen": 32, "whatev": 32, "cumbersom": 32, "robust": 32, "glom": 32, "everywher": 32, "strongest": 32, "no_extract": 32, "job_json": 32, "inputfil": 32, "jump": 32}, "objects": {"pikepdf": [[3, 0, 1, "", "Annotation"], [2, 0, 1, "", "Array"], [3, 0, 1, "", "AttachedFileSpec"], [2, 0, 1, "", "ContentStreamInlineImage"], [2, 0, 1, "", "ContentStreamInstruction"], [0, 3, 1, "", "DataDecodingError"], [2, 0, 1, "", "Dictionary"], [0, 3, 1, "", "ForeignObjectError"], [2, 0, 1, "", "Job"], [2, 0, 1, "", "Name"], [3, 0, 1, "", "NameTree"], [3, 0, 1, "", "NumberTree"], [2, 0, 1, "", "Object"], [3, 0, 1, "", "ObjectHelper"], [2, 0, 1, "", "ObjectStreamMode"], [2, 0, 1, "", "ObjectType"], [2, 0, 1, "", "Operator"], [0, 3, 1, "", "OutlineStructureError"], [3, 0, 1, "", "Page"], [0, 3, 1, "", "PasswordError"], [2, 0, 1, "", "Pdf"], [0, 3, 1, "", "PdfError"], [3, 0, 1, "", "PdfImage"], [3, 0, 1, "", "PdfInlineImage"], [3, 0, 1, "", "PdfMatrix"], [3, 0, 1, "", "Permissions"], [2, 0, 1, "", "Rectangle"], [2, 0, 1, "", "Stream"], [2, 0, 1, "", "StreamDecodeLevel"], [2, 0, 1, "", "String"], [1, 0, 1, "", "Token"], [1, 0, 1, "", "TokenFilter"], [1, 0, 1, "", "TokenType"], [0, 3, 1, "", "UnsupportedImageTypeError"], [2, 5, 1, "", "new"], [2, 5, 1, "", "open"], [1, 5, 1, "", "parse_content_stream"], [1, 5, 1, "", "unparse_content_stream"]], "pikepdf.Annotation": [[3, 1, 1, "", "appearance_dict"], [3, 1, 1, "", "appearance_state"], [3, 1, 1, "", "flags"], [3, 2, 1, "", "get_appearance_stream"], [3, 2, 1, "", "get_page_content_for_appearance"], [3, 1, 1, "", "subtype"]], "pikepdf.Array": [[2, 2, 1, "", "__new__"]], "pikepdf.AttachedFileSpec": [[3, 2, 1, "", "__init__"], [3, 1, 1, "", "description"], [3, 1, 1, "", "filename"], [3, 2, 1, "", "from_filepath"], [3, 2, 1, "", "get_all_filenames"], [3, 2, 1, "", "get_file"], [3, 1, 1, "", "obj"]], "pikepdf.ContentStreamInlineImage": [[2, 1, 1, "", "iimage"], [2, 1, 1, "", "operands"], [2, 1, 1, "", "operator"]], "pikepdf.ContentStreamInstruction": [[2, 1, 1, "", "operands"], [2, 1, 1, "", "operator"]], "pikepdf.Dictionary": [[2, 2, 1, "", "__new__"]], "pikepdf.Job": [[2, 2, 1, "", "__init__"], [2, 2, 1, "", "check_configuration"], [2, 1, 1, "", "creates_output"], [2, 1, 1, "", "encryption_status"], [2, 1, 1, "", "exit_code"], [2, 1, 1, "", "has_warnings"], [2, 1, 1, "", "message_prefix"], [2, 2, 1, "", "run"]], "pikepdf.Name": [[2, 2, 1, "", "__new__"]], "pikepdf.NameTree": [[3, 2, 1, "", "clear"], [3, 2, 1, "", "get"], [3, 2, 1, "", "new"], [3, 1, 1, "", "obj"], [3, 2, 1, "", "pop"], [3, 2, 1, "", "popitem"], [3, 2, 1, "", "setdefault"], [3, 2, 1, "", "update"]], "pikepdf.NumberTree": [[3, 2, 1, "", "clear"], [3, 2, 1, "", "get"], [3, 2, 1, "", "new"], [3, 2, 1, "", "pop"], [3, 2, 1, "", "popitem"], [3, 2, 1, "", "setdefault"], [3, 2, 1, "", "update"]], "pikepdf.Object": [[2, 2, 1, "", "append"], [2, 2, 1, "", "as_dict"], [2, 2, 1, "", "as_list"], [2, 2, 1, "", "emplace"], [2, 2, 1, "", "extend"], [2, 2, 1, "", "get"], [2, 2, 1, "", "get_raw_stream_buffer"], [2, 2, 1, "", "get_stream_buffer"], [2, 2, 1, "", "is_owned_by"], [2, 1, 1, "", "is_rectangle"], [2, 2, 1, "", "items"], [2, 2, 1, "", "keys"], [2, 1, 1, "", "objgen"], [2, 2, 1, "", "parse"], [2, 2, 1, "", "read_bytes"], [2, 2, 1, "", "read_raw_bytes"], [2, 2, 1, "", "same_owner_as"], [2, 1, 1, "", "stream_dict"], [2, 2, 1, "", "to_json"], [2, 2, 1, "", "unparse"], [2, 2, 1, "", "with_same_owner_as"], [2, 2, 1, "", "wrap_in_array"], [2, 2, 1, "", "write"]], "pikepdf.ObjectHelper": [[3, 1, 1, "", "obj"]], "pikepdf.ObjectStreamMode": [[2, 4, 1, "", "disable"], [2, 4, 1, "", "generate"], [2, 4, 1, "", "preserve"]], "pikepdf.ObjectType": [[2, 4, 1, "", "array"], [2, 4, 1, "", "boolean"], [2, 4, 1, "", "dictionary"], [2, 4, 1, "", "inlineimage"], [2, 4, 1, "", "integer"], [2, 4, 1, "", "name_"], [2, 4, 1, "", "null"], [2, 4, 1, "", "operator"], [2, 4, 1, "", "real"], [2, 4, 1, "", "reserved"], [2, 4, 1, "", "stream"], [2, 4, 1, "", "string"], [2, 4, 1, "", "uninitialized"]], "pikepdf.Page": [[3, 2, 1, "", "add_content_token_filter"], [3, 2, 1, "", "add_overlay"], [3, 2, 1, "", "add_resource"], [3, 2, 1, "", "add_underlay"], [3, 2, 1, "", "as_form_xobject"], [3, 2, 1, "", "calc_form_xobject_placement"], [3, 2, 1, "", "contents_add"], [3, 2, 1, "", "contents_coalesce"], [3, 1, 1, "", "cropbox"], [3, 2, 1, "", "externalize_inline_images"], [3, 2, 1, "", "get_filtered_contents"], [3, 1, 1, "", "images"], [3, 1, 1, "", "index"], [3, 1, 1, "", "label"], [3, 1, 1, "", "mediabox"], [3, 1, 1, "", "obj"], [3, 2, 1, "", "parse_contents"], [3, 2, 1, "", "remove_unreferenced_resources"], [3, 1, 1, "", "resources"], [3, 2, 1, "", "rotate"], [3, 1, 1, "", "trimbox"]], "pikepdf.Pdf": [[2, 1, 1, "", "Root"], [2, 2, 1, "", "add_blank_page"], [2, 1, 1, "", "allow"], [2, 1, 1, "", "attachments"], [2, 2, 1, "", "check"], [2, 2, 1, "", "check_linearization"], [2, 2, 1, "", "close"], [2, 2, 1, "", "copy_foreign"], [2, 1, 1, "", "docinfo"], [2, 1, 1, "", "encryption"], [2, 1, 1, "", "filename"], [2, 2, 1, "", "flatten_annotations"], [2, 2, 1, "", "generate_appearance_streams"], [2, 2, 1, "", "get_object"], [2, 2, 1, "", "get_warnings"], [2, 1, 1, "", "is_encrypted"], [2, 1, 1, "", "is_linearized"], [2, 2, 1, "", "make_indirect"], [2, 2, 1, "", "make_stream"], [2, 2, 1, "", "new"], [2, 1, 1, "", "objects"], [2, 2, 1, "", "open"], [2, 2, 1, "", "open_metadata"], [2, 2, 1, "", "open_outline"], [2, 1, 1, "", "owner_password_matched"], [2, 1, 1, "", "pages"], [2, 1, 1, "", "pdf_version"], [2, 2, 1, "", "remove_unreferenced_resources"], [2, 2, 1, "", "save"], [2, 2, 1, "", "show_xref_table"], [2, 1, 1, "", "trailer"], [2, 1, 1, "", "user_password_matched"]], "pikepdf.PdfImage": [[3, 2, 1, "", "as_pil_image"], [3, 1, 1, "", "bits_per_component"], [3, 1, 1, "", "colorspace"], [3, 1, 1, "", "decode_parms"], [3, 2, 1, "", "extract_to"], [3, 1, 1, "", "filter_decodeparms"], [3, 1, 1, "", "filters"], [3, 2, 1, "", "get_stream_buffer"], [3, 1, 1, "", "height"], [3, 1, 1, "", "icc"], [3, 1, 1, "", "image_mask"], [3, 1, 1, "", "indexed"], [3, 1, 1, "", "is_device_n"], [3, 1, 1, "", "is_inline"], [3, 1, 1, "", "is_separation"], [3, 1, 1, "", "mode"], [3, 1, 1, "", "palette"], [3, 2, 1, "", "read_bytes"], [3, 2, 1, "", "show"], [3, 1, 1, "", "size"], [3, 1, 1, "", "width"]], "pikepdf.PdfMatrix": [[3, 1, 1, "id0", "a"], [3, 1, 1, "id1", "b"], [3, 1, 1, "id2", "c"], [3, 1, 1, "id3", "d"], [3, 1, 1, "id4", "e"], [3, 2, 1, "", "encode"], [3, 1, 1, "id5", "f"], [3, 2, 1, "", "identity"], [3, 2, 1, "", "rotated"], [3, 2, 1, "", "scaled"], [3, 1, 1, "", "shorthand"], [3, 2, 1, "", "translated"]], "pikepdf.Permissions": [[3, 4, 1, "", "accessibility"], [3, 4, 1, "", "extract"], [3, 4, 1, "", "modify_annotation"], [3, 4, 1, "", "modify_assembly"], [3, 4, 1, "", "modify_form"], [3, 4, 1, "", "modify_other"], [3, 4, 1, "", "print_highres"], [3, 4, 1, "", "print_lowres"]], "pikepdf.Rectangle": [[2, 2, 1, "", "as_array"], [2, 1, 1, "", "height"], [2, 1, 1, "", "llx"], [2, 1, 1, "", "lly"], [2, 1, 1, "", "lower_left"], [2, 1, 1, "", "lower_right"], [2, 1, 1, "", "upper_left"], [2, 1, 1, "", "upper_right"], [2, 1, 1, "", "urx"], [2, 1, 1, "", "ury"], [2, 1, 1, "", "width"]], "pikepdf.Stream": [[2, 2, 1, "", "__new__"]], "pikepdf.StreamDecodeLevel": [[2, 4, 1, "", "all"], [2, 4, 1, "", "generalized"], [2, 4, 1, "", "none"], [2, 4, 1, "", "specialized"]], "pikepdf.String": [[2, 2, 1, "", "__new__"]], "pikepdf.Token": [[1, 1, 1, "", "raw_value"], [1, 1, 1, "", "type_"], [1, 1, 1, "", "value"]], "pikepdf.TokenFilter": [[1, 2, 1, "", "handle_token"]], "pikepdf.TokenType": [[1, 4, 1, "", "array_close"], [1, 4, 1, "", "array_open"], [1, 4, 1, "", "bad"], [1, 4, 1, "", "bool"], [1, 4, 1, "", "brace_close"], [1, 4, 1, "", "brace_open"], [1, 4, 1, "", "comment"], [1, 4, 1, "", "dict_close"], [1, 4, 1, "", "dict_open"], [1, 4, 1, "", "eof"], [1, 4, 1, "", "inline_image"], [1, 4, 1, "", "integer"], [1, 4, 1, "", "name_"], [1, 4, 1, "", "null"], [1, 4, 1, "", "real"], [1, 4, 1, "", "space"], [1, 4, 1, "", "word"]], "pikepdf._qpdf": [[3, 0, 1, "", "AttachedFile"], [3, 0, 1, "", "Attachments"], [2, 0, 1, "", "PageList"], [2, 0, 1, "", "_ObjectList"]], "pikepdf._qpdf.AttachedFile": [[3, 1, 1, "", "md5"], [3, 1, 1, "", "mime_type"], [3, 1, 1, "", "obj"], [3, 1, 1, "", "size"]], "pikepdf._qpdf.Attachments": [[3, 2, 1, "", "clear"], [3, 2, 1, "", "get"], [3, 2, 1, "", "items"], [3, 2, 1, "", "keys"], [3, 2, 1, "", "pop"], [3, 2, 1, "", "popitem"], [3, 2, 1, "", "setdefault"], [3, 2, 1, "", "update"], [3, 2, 1, "", "values"]], "pikepdf._qpdf.PageList": [[2, 2, 1, "", "append"], [2, 2, 1, "", "extend"], [2, 2, 1, "", "from_objgen"], [2, 2, 1, "", "index"], [2, 2, 1, "", "insert"], [2, 2, 1, "", "p"], [2, 2, 1, "", "remove"], [2, 2, 1, "", "reverse"]], "pikepdf._qpdf._ObjectList": [[2, 2, 1, "", "append"], [2, 2, 1, "", "clear"], [2, 2, 1, "", "count"], [2, 2, 1, "", "extend"], [2, 2, 1, "", "insert"], [2, 2, 1, "", "pop"], [2, 2, 1, "", "remove"]], "pikepdf.models": [[3, 0, 1, "", "Encryption"], [3, 0, 1, "", "EncryptionInfo"], [3, 0, 1, "", "EncryptionMethod"], [3, 0, 1, "", "Outline"], [3, 0, 1, "", "OutlineItem"], [3, 0, 1, "", "PdfMetadata"]], "pikepdf.models.Encryption": [[3, 4, 1, "", "R"], [3, 4, 1, "", "aes"], [3, 4, 1, "", "allow"], [3, 4, 1, "", "metadata"], [3, 4, 1, "", "owner"], [3, 4, 1, "", "user"]], "pikepdf.models.EncryptionInfo": [[3, 1, 1, "", "P"], [3, 1, 1, "", "R"], [3, 1, 1, "", "V"], [3, 1, 1, "", "bits"], [3, 1, 1, "", "encryption_key"], [3, 1, 1, "", "file_method"], [3, 1, 1, "", "stream_method"], [3, 1, 1, "", "string_method"], [3, 1, 1, "", "user_password"]], "pikepdf.models.EncryptionMethod": [[3, 4, 1, "", "aes"], [3, 4, 1, "", "aesv3"], [3, 4, 1, "", "none"], [3, 4, 1, "", "rc4"], [3, 4, 1, "", "unknown"]], "pikepdf.models.Outline": [[3, 1, 1, "", "root"]], "pikepdf.models.OutlineItem": [[3, 2, 1, "", "from_dictionary_object"], [3, 2, 1, "", "to_dictionary_object"]], "pikepdf.models.PdfMetadata": [[3, 2, 1, "", "load_from_docinfo"], [3, 1, 1, "", "pdfa_status"], [3, 1, 1, "", "pdfx_status"]], "pikepdf.settings": [[4, 5, 1, "", "get_decimal_precision"], [4, 5, 1, "", "set_decimal_precision"], [4, 5, 1, "", "set_flate_compression_level"]]}, "objtypes": {"0": "py:class", "1": "py:property", "2": "py:method", "3": "py:exception", "4": "py:attribute", "5": "py:function"}, "objnames": {"0": ["py", "class", "Python class"], "1": ["py", "property", "Python property"], "2": ["py", "method", "Python method"], "3": ["py", "exception", "Python exception"], "4": ["py", "attribute", "Python attribute"], "5": ["py", "function", "Python function"]}, "titleterms": {"except": 0, "content": [1, 2, 19, 30], "stream": [1, 2, 19, 31], "parser": 1, "token": 1, "filter": 1, "main": 2, "object": [2, 24, 31], "construct": 2, "common": 2, "pdf": [2, 18, 19, 22, 24, 28, 29, 30, 32], "data": 2, "structur": [2, 25], "element": 2, "intern": [2, 7], "job": [2, 32], "support": [3, 6], "model": [3, 24], "set": 4, "pikepdf": [5, 9], "document": [5, 6, 22, 29], "At": 5, "glanc": 5, "requir": [5, 6], "similar": 5, "librari": [5, 6], "In": 5, "us": [5, 9, 29], "introduct": 5, "releas": [5, 11], "note": [5, 11, 18], "topic": 5, "api": 5, "refer": 5, "instal": 6, "basic": 6, "binari": 6, "wheel": 6, "avail": 6, "python": [6, 8, 9, 31], "platform": 6, "debian": 6, "ubuntu": 6, "other": [6, 20, 29], "apt": 6, "base": 6, "distribut": 6, "fedora": 6, "alpin": 6, "linux": 6, "freebsd": 6, "build": [6, 9], "from": [6, 19, 29], "sourc": [6, 9], "gcc": 6, "clang": 6, "link": [6, 9], "system": 6, "user": 6, "On": 6, "window": 6, "visual": 6, "studio": 6, "2015": 6, "against": [6, 9], "qpdf": [6, 9, 32], "tree": [6, 9, 23], "pypy3": 6, "architectur": 7, "thread": 7, "safeti": 7, "file": [7, 18], "handl": 7, "contribut": 8, "guidelin": 8, "big": 8, "chang": [8, 15, 16, 32], "code": 8, "style": 8, "c": [8, 9], "test": 8, "new": [8, 15], "depend": 8, "english": 8, "guid": 8, "known": 8, "port": 8, "packag": 8, "debug": 9, "enabl": 9, "trace": 9, "gdb": 9, "compil": 9, "valgrind": 9, "profil": 9, "pymemtrac": 9, "resourc": 10, "v0": 12, "10": [12, 13, 14], "2": [12, 13, 14, 15, 16, 17], "fix": [12, 15], "1": [12, 13, 14, 15, 16, 17], "0": [12, 13, 14, 15, 16, 17], "9": [12, 13, 14], "updat": [12, 22], "break": [12, 15, 16], "3": [12, 13, 14, 16, 17], "7": [12, 13, 14], "6": [12, 13, 14, 17], "5": [12, 13, 14, 16, 17], "4": [12, 13, 14, 16, 17], "v1": 13, "19": 13, "18": 13, "17": 13, "16": [13, 14], "15": [13, 14], "14": [13, 14], "13": [13, 14], "12": [13, 14], "11": [13, 14], "8": [13, 14], "v2": 14, "0b2": 14, "0b1": 14, "v3": 15, "function": 15, "v4": 16, "v5": 17, "attach": 18, "gener": 18, "how": [18, 19], "find": 18, "viewer": [18, 28], "creat": [18, 25], "annot": 18, "work": [19, 21, 27], "pretti": 19, "print": 19, "draw": 19, "imag": [19, 21], "edit": [19, 25], "robustli": 19, "extract": [19, 21], "text": 19, "charact": 20, "encod": 20, "pdfdocencod": 20, "codec": 20, "plai": 21, "replac": 21, "an": 21, "remov": [21, 22], "metadata": 22, "automat": 22, "access": [22, 29], "item": [22, 32], "check": 22, "A": 22, "conform": 22, "notic": 22, "applic": 22, "develop": 22, "low": 22, "level": 22, "xmp": 22, "The": 22, "info": 22, "dictionari": [22, 32], "name": 23, "make": 24, "lifecycl": 24, "memori": 24, "manag": 24, "indirect": 24, "helper": 24, "outlin": 25, "destin": 25, "overlai": 26, "underlai": 26, "watermark": 26, "n": 26, "up": 26, "page": [27, 29, 32], "box": 27, "default": 28, "appear": 28, "pagelayout": 28, "definit": 28, "pagemod": 28, "split": 29, "merg": 29, "assembl": 29, "singl": 29, "concaten": 29, "sever": 29, "revers": 29, "order": 29, "copi": 29, "emplac": 29, "within": 29, "count": 29, "number": 29, "label": 29, "inform": 29, "root": 29, "secur": [30, 32], "password": 30, "unicod": 30, "restrict": 30, "digit": 30, "signatur": 30, "certif": 30, "read": 31, "i": 31, "o": 31, "tutori": 32, "open": 32, "save": 32, "inspect": 32, "repr": 32, "output": 32, "attribut": 32, "notat": 32, "delet": 32, "run": 32, "through": 32, "next": 32, "step": 32}, "envversion": {"sphinx.domains.c": 2, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 6, "sphinx.domains.index": 1, "sphinx.domains.javascript": 2, "sphinx.domains.math": 2, "sphinx.domains.python": 3, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx.ext.intersphinx": 1, "sphinx": 56}})